unit chrSearchResultWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

type
  TchrSearchResultFrm = class(TForm)
    pnToolbar: TPanel;
    stShowBlock: TStaticText;
    cbBlocks: TComboBox;
    btnClose: TButton;
    lbChars: TListBox;
    StatusBar: TStatusBar;
    stFont: TStaticText;
    cbFonts: TComboBox;
    procedure lbCharsClick(Sender: TObject);
    procedure lbCharsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure cbBlocksChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure cbFontsChange(Sender: TObject);
  private
    procedure ItemChanged;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  chrSearchResultFrm: TchrSearchResultFrm;

implementation

uses mainWin, chrWin, UnicodeData;

{$R *.dfm}

procedure TchrSearchResultFrm.lbCharsClick(Sender: TObject);
begin
  ItemChanged;
end;

procedure TchrSearchResultFrm.lbCharsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ItemChanged;
end;

procedure TchrSearchResultFrm.cbBlocksChange(Sender: TObject);
var
  i: Integer;
  j: Integer;
begin
  for i := 0 to UCD.BlockCount - 1 do
    if SameText(cbBlocks.Items[cbBlocks.ItemIndex], UCD.Blocks[i].BlockName) then
    begin
      lbChars.Items.BeginUpdate;
      lbChars.Items.Clear;
      for j := UCD.Blocks[i].BlockBegin to UCD.Blocks[i].BlockEnd do
        lbChars.Items.Add(Chr(j));
      lbChars.Items.EndUpdate;
      break;
    end;
end;

procedure TchrSearchResultFrm.cbFontsChange(Sender: TObject);
begin
  if (cbFonts.ItemIndex <> -1) and (cbFonts.Items[cbFonts.ItemIndex] <> '--') then
    lbChars.Font.Name := cbFonts.Items[cbFonts.ItemIndex];
end;

procedure TchrSearchResultFrm.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  cbBlocks.Items.BeginUpdate;
  cbBlocks.Items.Clear;
  for i := 0 to UCD.BlockCount - 1 do
  begin
    if UCD.Blocks[i].BlockEnd <= $FFFF then
      cbBlocks.Items.Add(UCD.Blocks[i].BlockName);
  end;
  cbBlocks.Items.EndUpdate;

  cbFonts.Items.BeginUpdate;
  cbFonts.Items.Clear;
  for i := 0 to mainFrm.Editor.FallbackFonts.Count - 1 do
    cbFonts.Items.Add(mainFrm.Editor.FallbackFonts[i]);
  cbFonts.Items.Add('--');
  for i := 0 to Screen.Fonts.Count - 1 do
    if Copy(Screen.Fonts[i], 1, 1) <> '@' then
      cbFonts.Items.Add(Screen.Fonts[i]);
  cbFonts.Items.EndUpdate;
end;

procedure TchrSearchResultFrm.FormResize(Sender: TObject);
begin
  lbChars.Columns := lbChars.ClientWidth div Abs(lbChars.Font.Height);
end;

procedure TchrSearchResultFrm.ItemChanged;
var
  c: char;
begin
  if (lbChars.ItemIndex <> -1) and (Length(lbChars.Items[lbChars.ItemIndex]) = 1) then
  begin
    c := lbChars.Items[lbChars.ItemIndex][1];
    mainFrm.CharacterInfo(c);
    StatusBar.SimpleText := Format('%s: %s (in block %s)',
     [chrFrm.eCode.Text, chrFrm.eChrName.Text, chrFrm.eChrBlock.Text]);
  end;
end;

end.
