﻿unit mainWin;

interface

{$WARN SYMBOL_PLATFORM OFF}

uses
  Windows, Types, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TextEditor, ActnList, ComCtrls, TabControl, Menus, ExtCtrls, StdCtrls,
  ZoomControl, TextEncodings, AppEvnts, BitmapEffects;

const
  REJBRAND_MUTEX_RTE_RTEDITOR = 'Rejbrand Text Editor';
  FILE_SIZE_LIMIT = 500 * 1024 * 1024;

type
  TTaskDialogHelper = class helper for TTaskDialog
    function ExecuteModally: boolean;
  end;

  TmainFrm = class(TForm)
    ActionList: TActionList;
    aNew: TAction;
    Editor: TTextEditor;
    TabList: TSimpleTabControl;
    aOpen: TAction;
    aSave: TAction;
    aSaveAs: TAction;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    aClose: TAction;
    Close1: TMenuItem;
    aExit: TAction;
    N2: TMenuItem;
    Exit1: TMenuItem;
    aRevert: TAction;
    Revert1: TMenuItem;
    aDeleteFile: TAction;
    Deletefile1: TMenuItem;
    aShellExecuteFile: TAction;
    Shellrunfile1: TMenuItem;
    aOpenFolder: TAction;
    Openfolder1: TMenuItem;
    aPrint: TAction;
    N3: TMenuItem;
    Print1: TMenuItem;
    aHTMLExport: TAction;
    ExporttoHTML1: TMenuItem;
    aPrinterSetup: TAction;
    Printersetup1: TMenuItem;
    Edit1: TMenuItem;
    aUndo: TAction;
    aRedo: TAction;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N4: TMenuItem;
    aCut: TAction;
    aCopy: TAction;
    aPaste: TAction;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    aClear: TAction;
    Clear1: TMenuItem;
    N5: TMenuItem;
    aSelectAll: TAction;
    aSelectAll1: TMenuItem;
    aSelectWord: TAction;
    Selectword1: TMenuItem;
    aSelectLine: TAction;
    Selectline1: TMenuItem;
    N6: TMenuItem;
    aClearLine: TAction;
    Clearline1: TMenuItem;
    aPerformWordWrap: TAction;
    Performwordwrap1: TMenuItem;
    aSortLines: TAction;
    Sortlines1: TMenuItem;
    N7: TMenuItem;
    aAddIndent: TAction;
    aRemoveIndent: TAction;
    aRemoveAllIndent: TAction;
    Increaseindent1: TMenuItem;
    Removeallindent1: TMenuItem;
    Removeallindent2: TMenuItem;
    aTrimRight: TAction;
    rimright1: TMenuItem;
    aUpperCase: TAction;
    aLowerCase: TAction;
    aInvertCase: TAction;
    aSentenceCase: TAction;
    aCamelCase: TAction;
    N8: TMenuItem;
    Charactercase1: TMenuItem;
    ouppercase1: TMenuItem;
    olowercase1: TMenuItem;
    Invertcase1: TMenuItem;
    osentencecase1: TMenuItem;
    ocamelcase1: TMenuItem;
    aROT13: TAction;
    aCaesar: TAction;
    aVigenereEncrypt: TAction;
    aVigenereDecrypt: TAction;
    Encryption1: TMenuItem;
    PerformROT131: TMenuItem;
    Caesarcipher1: TMenuItem;
    Vigenreencrypt1: TMenuItem;
    Vigenredecrypt1: TMenuItem;
    aHistory: TAction;
    History1: TMenuItem;
    pnSearch: TPanel;
    StaticText1: TStaticText;
    eFind: TEdit;
    cbFindMatchCase: TCheckBox;
    cbFindWholeWords: TCheckBox;
    cbFindNewline: TCheckBox;
    btnFindPrev: TButton;
    btnFindNext: TButton;
    aFind: TAction;
    Find1: TMenuItem;
    Find2: TMenuItem;
    stNumMatches: TStaticText;
    aFindNext: TAction;
    aFindPrev: TAction;
    Previous1: TMenuItem;
    Next1: TMenuItem;
    aReplace: TAction;
    Redo2: TMenuItem;
    N9: TMenuItem;
    aGoTo: TAction;
    N10: TMenuItem;
    Goto1: TMenuItem;
    aStatusBar: TAction;
    StatusBar: TStatusBar;
    View1: TMenuItem;
    Statusbar1: TMenuItem;
    aRuler: TAction;
    Ruler1: TMenuItem;
    aToggleFocus: TAction;
    aDateTime: TAction;
    Insert1: TMenuItem;
    Insertdateandtime1: TMenuItem;
    aCustomDateTime: TAction;
    Customdateortime1: TMenuItem;
    TabPopup: TPopupMenu;
    Save2: TMenuItem;
    Saveas2: TMenuItem;
    Deletefile2: TMenuItem;
    Shellrunfile2: TMenuItem;
    Openfolder2: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    Close2: TMenuItem;
    aInsertChar: TAction;
    Character1: TMenuItem;
    ZoomControl: TZoomControl;
    StatusMessagePopup: TPopupMenu;
    StatusPosPopup: TPopupMenu;
    Goto2: TMenuItem;
    aMakeUnique: TAction;
    Makelinesunique1: TMenuItem;
    aNextTab: TAction;
    aPrevTab: TAction;
    TabListPopup: TPopupMenu;
    Previoustab1: TMenuItem;
    Nexttab1: TMenuItem;
    N11: TMenuItem;
    New2: TMenuItem;
    N14: TMenuItem;
    aHTMLH1: TAction;
    aHTMLH2: TAction;
    aHTMLH3: TAction;
    aHTMLH4: TAction;
    aHTMLH5: TAction;
    aHTMLH6: TAction;
    aHTMLP: TAction;
    aHTMLDiv: TAction;
    aHTMLBr: TAction;
    aHTMLUL: TAction;
    aHTMLOL: TAction;
    aHTMLLI: TAction;
    aHTMLnbsp: TAction;
    aHTMLB: TAction;
    aHTMLI: TAction;
    aHTMLEM: TAction;
    aHTMLstrong: TAction;
    aHTMLU: TAction;
    aHTMLspan: TAction;
    N15: TMenuItem;
    XHTML1: TMenuItem;
    Headings1: TMenuItem;
    Heading11: TMenuItem;
    Heading21: TMenuItem;
    Heading31: TMenuItem;
    Heading41: TMenuItem;
    Heading51: TMenuItem;
    Heading61: TMenuItem;
    Paragraph1: TMenuItem;
    Division1: TMenuItem;
    N16: TMenuItem;
    Nonbreakingspace1: TMenuItem;
    aHTMLBr1: TMenuItem;
    N17: TMenuItem;
    aHTMLUL1: TMenuItem;
    aHTMLOL1: TMenuItem;
    aHTMLLI1: TMenuItem;
    N18: TMenuItem;
    Bold1: TMenuItem;
    Italic1: TMenuItem;
    Emphasis1: TMenuItem;
    Strongemphasis1: TMenuItem;
    Underline1: TMenuItem;
    Span1: TMenuItem;
    N19: TMenuItem;
    aHTMLtable: TAction;
    aHTMLtr: TAction;
    aHTMLth: TAction;
    aHTMLtd: TAction;
    able1: TMenuItem;
    ablerow1: TMenuItem;
    ableheadingcell1: TMenuItem;
    abledatacell1: TMenuItem;
    aFont: TAction;
    Options1: TMenuItem;
    Font1: TMenuItem;
    aPasteAs: TAction;
    Pasteas1: TMenuItem;
    aInsertColor: TAction;
    N20: TMenuItem;
    Colourcode1: TMenuItem;
    aSetBgColor: TAction;
    Colours1: TMenuItem;
    Setbackgroundcolour1: TMenuItem;
    aSetRowHighlightColor: TAction;
    Setlinehighlightcolour1: TMenuItem;
    aSetSelBgColor: TAction;
    Setselectionbackgroundcolour1: TMenuItem;
    aSetSelFgColor: TAction;
    Setselectiontextcolour1: TMenuItem;
    aSetSearchHighlightColor: TAction;
    Setsearchhighlightcolour1: TMenuItem;
    aSetSearchHighlightTextColor: TAction;
    Setsearchhighlighttextcolour1: TMenuItem;
    aSetBracketHighlightColor: TAction;
    Setbrackethighlightcolour1: TMenuItem;
    aSetTextColor: TAction;
    Settextcolour1: TMenuItem;
    aSetRulerBackgroundColor: TAction;
    Setrulerbackgroundcolour1: TMenuItem;
    aSetRulerTextColor: TAction;
    Setrulertextcolour1: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    aUseSystemDefaultColors: TAction;
    N24: TMenuItem;
    Usesystemdefaultcolours1: TMenuItem;
    XMLFormattingProcessor1: TXMLFormattingProcessor;
    CSSFormattingProcessor1: TCSSFormattingProcessor;
    INIFormattingProcessor1: TINIFormattingProcessor;
    PascalFormattingProcessor1: TPascalFormattingProcessor;
    AlgoSimFormattingProcessor1: TAlgoSimFormattingProcessor;
    HTMLFormattingProcessor1: THTMLFormattingProcessor;
    MediaWikiFormattingProcessor1: TMediaWikiFormattingProcessor;
    aFPXML: TAction;
    aFPHTML: TAction;
    aFPCSS: TAction;
    aFPMW: TAction;
    aFPINI: TAction;
    aFPPascal: TAction;
    aFPAS: TAction;
    Syntaxhighlighting1: TMenuItem;
    XML1: TMenuItem;
    HTMLwithCSSsupport1: TMenuItem;
    CSS1: TMenuItem;
    MediaWiki1: TMenuItem;
    ObjectPascalDelphi1: TMenuItem;
    AlgoSim1: TMenuItem;
    INI1: TMenuItem;
    aFPNone: TAction;
    N25: TMenuItem;
    None1: TMenuItem;
    N26: TMenuItem;
    aRowHighlight: TAction;
    aBracketHighlight: TAction;
    Linehighlight1: TMenuItem;
    Brackethighlight1: TMenuItem;
    aHiddenChars: TAction;
    Showhiddencharacters1: TMenuItem;
    aCaretBeyondEOL: TAction;
    N27: TMenuItem;
    CaretbeyondEOL1: TMenuItem;
    aAutoIndent: TAction;
    Autoindent1: TMenuItem;
    aAutoReplace: TAction;
    Autoreplace1: TMenuItem;
    aSetTabLength: TAction;
    Settablength1: TMenuItem;
    N28: TMenuItem;
    aReadOnly: TAction;
    Readonly1: TMenuItem;
    aRestoreSettings: TAction;
    N29: TMenuItem;
    Restoredefaultsettings1: TMenuItem;
    aSettings: TAction;
    Settablength2: TMenuItem;
    aEncUTF8: TAction;
    aEncASCII: TAction;
    aEncUTF16LE: TAction;
    mnuEncoding: TMenuItem;
    ASCII1: TMenuItem;
    UTF81: TMenuItem;
    UTF16LE1: TMenuItem;
    aEncUTF16BE: TAction;
    UTF16BE1: TMenuItem;
    aEncANSI: TAction;
    aEncUTF32LE: TAction;
    aEncUTF32BE: TAction;
    N8bitextendedASCII1: TMenuItem;
    UTF32LE1: TMenuItem;
    UTF32BE1: TMenuItem;
    N30: TMenuItem;
    aEncMagicBytes: TAction;
    N31: TMenuItem;
    MagicbytesBOM1: TMenuItem;
    aEncCRLF: TAction;
    aEncLF: TAction;
    N32: TMenuItem;
    CarriagereturnCFlinefeedLF1: TMenuItem;
    LinefeedLF1: TMenuItem;
    mnuTabs: TMenuItem;
    Previoustab2: TMenuItem;
    Nexttab2: TMenuItem;
    N33: TMenuItem;
    aFillWithchar: TAction;
    Fillwithcharacter1: TMenuItem;
    aBlockPaste: TAction;
    Blockpaste1: TMenuItem;
    aStatistics: TAction;
    ools1: TMenuItem;
    Statistics1: TMenuItem;
    aTruncateAt: TAction;
    runcateat1: TMenuItem;
    aAbout: TAction;
    Help1: TMenuItem;
    About1: TMenuItem;
    aTipOfTheDay: TAction;
    ipoftheday1: TMenuItem;
    N34: TMenuItem;
    aSetFPAssoc: TAction;
    N35: TMenuItem;
    Setassociations1: TMenuItem;
    ApplicationEvents: TApplicationEvents;
    aHelp: TAction;
    Keyboardcommandsandotherreference1: TMenuItem;
    aFilter: TAction;
    Filterlines1: TMenuItem;
    aDuplicateBuffer: TAction;
    aSelectionToNewBuffer: TAction;
    Duplicatebuffer2: TMenuItem;
    aSaveAll: TAction;
    Saveall1: TMenuItem;
    N37: TMenuItem;
    aCloseAll: TAction;
    Closeall1: TMenuItem;
    aCloseAllWithoutSave: TAction;
    Closeallwithoutsaving1: TMenuItem;
    N38: TMenuItem;
    aCheckASCII: TAction;
    N39: TMenuItem;
    CheckiffileisASCIIonly1: TMenuItem;
    aLoremIpsum: TAction;
    Loremipsum1: TMenuItem;
    Saveall2: TMenuItem;
    Closeall2: TMenuItem;
    aStatusMsgCopy: TAction;
    Copystatusbarmessagetoclipboard1: TMenuItem;
    aShowAutoReplaceList: TAction;
    aShowAutoReplaceList1: TMenuItem;
    aNotificationWindow: TAction;
    N36: TMenuItem;
    Duplicatebuffer1: TMenuItem;
    Newbufferfromselection1: TMenuItem;
    aAdvStatistics: TAction;
    Advancedstatistics1: TMenuItem;
    aChrFind: TAction;
    Charactersearch1: TMenuItem;
    N40: TMenuItem;
    N41: TMenuItem;
    OntheWWW1: TMenuItem;
    mnuURLARH: TMenuItem;
    mnuURLRTE: TMenuItem;
    mnuURLRTEdoc: TMenuItem;
    aItUpperCase: TAction;
    aItLowerCase: TAction;
    aItSuperscript: TAction;
    aItSubscript: TAction;
    aItParenthesized: TAction;
    aItCircled: TAction;
    aItDoublyCircled: TAction;
    aItNone: TAction;
    N42: TMenuItem;
    Inputtransforms1: TMenuItem;
    None2: TMenuItem;
    Uppercase1: TMenuItem;
    Lowercase1: TMenuItem;
    Superscript1: TMenuItem;
    Subscript1: TMenuItem;
    Parenthesized1: TMenuItem;
    Encircled1: TMenuItem;
    Doublyencircled1: TMenuItem;
    N43: TMenuItem;
    aInsertCharByDescriptionSearch: TAction;
    procedure FormCreate(Sender: TObject);
    procedure aNewExecute(Sender: TObject);
    procedure TabListChange(Sender: TObject);
    procedure aOpenExecute(Sender: TObject);
    procedure aSaveExecute(Sender: TObject);
    procedure aSaveAsExecute(Sender: TObject);
    procedure aCloseExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure aExitExecute(Sender: TObject);
    procedure aRevertExecute(Sender: TObject);
    procedure aRevertUpdate(Sender: TObject);
    procedure aDeleteFileUpdate(Sender: TObject);
    procedure aDeleteFileExecute(Sender: TObject);
    procedure aShellExecuteFileUpdate(Sender: TObject);
    procedure aShellExecuteFileExecute(Sender: TObject);
    procedure aOpenFolderUpdate(Sender: TObject);
    procedure aOpenFolderExecute(Sender: TObject);
    procedure aPrintExecute(Sender: TObject);
    procedure aHTMLExportExecute(Sender: TObject);
    procedure aPrinterSetupExecute(Sender: TObject);
    procedure aUndoUpdate(Sender: TObject);
    procedure aUndoExecute(Sender: TObject);
    procedure aRedoUpdate(Sender: TObject);
    procedure aRedoExecute(Sender: TObject);
    procedure aCutUpdate(Sender: TObject);
    procedure aCutExecute(Sender: TObject);
    procedure aCopyUpdate(Sender: TObject);
    procedure aCopyExecute(Sender: TObject);
    procedure aPasteUpdate(Sender: TObject);
    procedure aPasteExecute(Sender: TObject);
    procedure aClearUpdate(Sender: TObject);
    procedure aClearExecute(Sender: TObject);
    procedure aSelectAllUpdate(Sender: TObject);
    procedure aSelectAllExecute(Sender: TObject);
    procedure aSelectWordExecute(Sender: TObject);
    procedure aSelectWordUpdate(Sender: TObject);
    procedure aSelectLineUpdate(Sender: TObject);
    procedure aSelectLineExecute(Sender: TObject);
    procedure aClearLineUpdate(Sender: TObject);
    procedure aClearLineExecute(Sender: TObject);
    procedure aPerformWordWrapUpdate(Sender: TObject);
    procedure aPerformWordWrapExecute(Sender: TObject);
    procedure aSortLinesUpdate(Sender: TObject);
    procedure aSortLinesExecute(Sender: TObject);
    procedure aAddIndentExecute(Sender: TObject);
    procedure aRemoveIndentExecute(Sender: TObject);
    procedure aRemoveAllIndentExecute(Sender: TObject);
    procedure aTrimRightExecute(Sender: TObject);
    procedure aUpperCaseExecute(Sender: TObject);
    procedure aUpperCaseUpdate(Sender: TObject);
    procedure aLowerCaseUpdate(Sender: TObject);
    procedure aLowerCaseExecute(Sender: TObject);
    procedure aInvertCaseUpdate(Sender: TObject);
    procedure aInvertCaseExecute(Sender: TObject);
    procedure aSentenceCaseUpdate(Sender: TObject);
    procedure aSentenceCaseExecute(Sender: TObject);
    procedure aCamelCaseUpdate(Sender: TObject);
    procedure aCamelCaseExecute(Sender: TObject);
    procedure aROT13Update(Sender: TObject);
    procedure aROT13Execute(Sender: TObject);
    procedure aCaesarUpdate(Sender: TObject);
    procedure aCaesarExecute(Sender: TObject);
    procedure aVigenereEncryptUpdate(Sender: TObject);
    procedure aVigenereEncryptExecute(Sender: TObject);
    procedure aVigenereDecryptUpdate(Sender: TObject);
    procedure aVigenereDecryptExecute(Sender: TObject);
    procedure aHistoryExecute(Sender: TObject);
    procedure aFindExecute(Sender: TObject);
    procedure eFindChange(Sender: TObject);
    procedure cbFindMatchCaseClick(Sender: TObject);
    procedure aFindNextUpdate(Sender: TObject);
    procedure aFindNextExecute(Sender: TObject);
    procedure aFindPrevUpdate(Sender: TObject);
    procedure aFindPrevExecute(Sender: TObject);
    procedure EditorFindDataClear(Sender: TObject);
    procedure eFindKeyPress(Sender: TObject; var Key: Char);
    procedure aReplaceExecute(Sender: TObject);
    procedure aGoToExecute(Sender: TObject);
    procedure aStatusBarUpdate(Sender: TObject);
    procedure aStatusBarExecute(Sender: TObject);
    procedure aRulerUpdate(Sender: TObject);
    procedure aRulerExecute(Sender: TObject);
    procedure aToggleFocusExecute(Sender: TObject);
    procedure aDateTimeExecute(Sender: TObject);
    procedure aCustomDateTimeExecute(Sender: TObject);
    procedure aInsertCharExecute(Sender: TObject);
    procedure StatusBarResize(Sender: TObject);
    procedure EditorSelChange(Sender: TObject);
    procedure EditorSimpleNotification(Sender: TObject; MsgID: Cardinal;
      const AStr: string);
    procedure EditorKeyPress(Sender: TObject; var Key: Char);
    procedure TabListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure ZoomControlChange(Sender: TObject);
    procedure EditorZoomChange(Sender: TObject);
    procedure StatusBarContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure StatusBarDblClick(Sender: TObject);
    procedure aMakeUniqueUpdate(Sender: TObject);
    procedure aMakeUniqueExecute(Sender: TObject);
    procedure aNextTabUpdate(Sender: TObject);
    procedure aNextTabExecute(Sender: TObject);
    procedure aPrevTabUpdate(Sender: TObject);
    procedure aPrevTabExecute(Sender: TObject);
    procedure aHTMLH1Execute(Sender: TObject);
    procedure aHTMLH2Execute(Sender: TObject);
    procedure aHTMLH3Execute(Sender: TObject);
    procedure aHTMLH4Execute(Sender: TObject);
    procedure aHTMLH5Execute(Sender: TObject);
    procedure aHTMLH6Execute(Sender: TObject);
    procedure aHTMLPExecute(Sender: TObject);
    procedure aHTMLDivExecute(Sender: TObject);
    procedure aHTMLBrExecute(Sender: TObject);
    procedure aHTMLULExecute(Sender: TObject);
    procedure aHTMLOLExecute(Sender: TObject);
    procedure aHTMLLIExecute(Sender: TObject);
    procedure aHTMLnbspExecute(Sender: TObject);
    procedure aHTMLBExecute(Sender: TObject);
    procedure aHTMLIExecute(Sender: TObject);
    procedure aHTMLEMExecute(Sender: TObject);
    procedure aHTMLstrongExecute(Sender: TObject);
    procedure aHTMLUExecute(Sender: TObject);
    procedure aHTMLspanExecute(Sender: TObject);
    procedure aHTMLtableExecute(Sender: TObject);
    procedure aHTMLtrExecute(Sender: TObject);
    procedure aHTMLthExecute(Sender: TObject);
    procedure aHTMLtdExecute(Sender: TObject);
    procedure aFontExecute(Sender: TObject);
    procedure aPasteAsExecute(Sender: TObject);
    procedure aPasteAsUpdate(Sender: TObject);
    procedure EditorOverwriteChange(Sender: TObject);
    procedure aInsertColorExecute(Sender: TObject);
    procedure aSetBgColorExecute(Sender: TObject);
    procedure aSetRowHighlightColorExecute(Sender: TObject);
    procedure aSetSelBgColorExecute(Sender: TObject);
    procedure aSetSelFgColorExecute(Sender: TObject);
    procedure aSetSearchHighlightColorExecute(Sender: TObject);
    procedure aSetSearchHighlightTextColorExecute(Sender: TObject);
    procedure aSetBracketHighlightColorExecute(Sender: TObject);
    procedure aSetTextColorExecute(Sender: TObject);
    procedure aSetRulerBackgroundColorExecute(Sender: TObject);
    procedure aSetRulerTextColorExecute(Sender: TObject);
    procedure aUseSystemDefaultColorsUpdate(Sender: TObject);
    procedure aUseSystemDefaultColorsExecute(Sender: TObject);
    procedure aSetBgColorUpdate(Sender: TObject);
    procedure aSetTextColorUpdate(Sender: TObject);
    procedure aSetSelBgColorUpdate(Sender: TObject);
    procedure aSetSelFgColorUpdate(Sender: TObject);
    procedure aFPXMLExecute(Sender: TObject);
    procedure aFPXMLUpdate(Sender: TObject);
    procedure aFPHTMLExecute(Sender: TObject);
    procedure aFPHTMLUpdate(Sender: TObject);
    procedure aFPCSSExecute(Sender: TObject);
    procedure aFPCSSUpdate(Sender: TObject);
    procedure aFPMWExecute(Sender: TObject);
    procedure aFPMWUpdate(Sender: TObject);
    procedure aFPINIExecute(Sender: TObject);
    procedure aFPINIUpdate(Sender: TObject);
    procedure aFPPascalExecute(Sender: TObject);
    procedure aFPPascalUpdate(Sender: TObject);
    procedure aFPASExecute(Sender: TObject);
    procedure aFPASUpdate(Sender: TObject);
    procedure aFPNoneExecute(Sender: TObject);
    procedure aFPNoneUpdate(Sender: TObject);
    procedure aRowHighlightExecute(Sender: TObject);
    procedure aRowHighlightUpdate(Sender: TObject);
    procedure aBracketHighlightExecute(Sender: TObject);
    procedure aBracketHighlightUpdate(Sender: TObject);
    procedure aHiddenCharsExecute(Sender: TObject);
    procedure aHiddenCharsUpdate(Sender: TObject);
    procedure aCaretBeyondEOLExecute(Sender: TObject);
    procedure aCaretBeyondEOLUpdate(Sender: TObject);
    procedure aAutoIndentExecute(Sender: TObject);
    procedure aAutoIndentUpdate(Sender: TObject);
    procedure aAutoReplaceExecute(Sender: TObject);
    procedure aAutoReplaceUpdate(Sender: TObject);
    procedure aSetTabLengthExecute(Sender: TObject);
    procedure aReadOnlyExecute(Sender: TObject);
    procedure aReadOnlyUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure aRestoreSettingsExecute(Sender: TObject);
    procedure aSettingsExecute(Sender: TObject);
    procedure EditorPrintBegin(Sender: TObject; NumSteps: Integer);
    procedure EditorPrintEnd(Sender: TObject);
    function EditorPrintProgress(Sender: TObject; CurStep,
      NumSteps: Integer): Boolean;
    procedure aEncUTF8Update(Sender: TObject);
    procedure aEncUTF8Execute(Sender: TObject);
    procedure aEncASCIIExecute(Sender: TObject);
    procedure aEncASCIIUpdate(Sender: TObject);
    procedure aEncUTF16LEUpdate(Sender: TObject);
    procedure aEncUTF16LEExecute(Sender: TObject);
    procedure aEncUTF16BEUpdate(Sender: TObject);
    procedure aEncUTF16BEExecute(Sender: TObject);
    procedure aEncANSIExecute(Sender: TObject);
    procedure aEncANSIUpdate(Sender: TObject);
    procedure aEncUTF32LEExecute(Sender: TObject);
    procedure aEncUTF32LEUpdate(Sender: TObject);
    procedure aEncUTF32BEExecute(Sender: TObject);
    procedure aEncUTF32BEUpdate(Sender: TObject);
    procedure aEncMagicBytesExecute(Sender: TObject);
    procedure aEncMagicBytesUpdate(Sender: TObject);
    procedure aEncCRLFExecute(Sender: TObject);
    procedure aEncCRLFUpdate(Sender: TObject);
    procedure aEncLFUpdate(Sender: TObject);
    procedure aEncLFExecute(Sender: TObject);
    procedure EditorModified(Sender: TObject);
    procedure TabsMenuOpen(Sender: TObject);
    procedure aFillWithcharUpdate(Sender: TObject);
    procedure aFillWithcharExecute(Sender: TObject);
    procedure aBlockPasteUpdate(Sender: TObject);
    procedure aBlockPasteExecute(Sender: TObject);
    procedure aStatisticsExecute(Sender: TObject);
    procedure aTruncateAtExecute(Sender: TObject);
    procedure aAboutExecute(Sender: TObject);
    procedure aTipOfTheDayExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure aSetFPAssocExecute(Sender: TObject);
    procedure ApplicationEventsHint(Sender: TObject);
    procedure aHelpExecute(Sender: TObject);
    procedure ApplicationEventsModalBegin(Sender: TObject);
    procedure ApplicationEventsModalEnd(Sender: TObject);
    procedure aFilterExecute(Sender: TObject);
    procedure aDuplicateBufferExecute(Sender: TObject);
    procedure aSelectionToNewBufferExecute(Sender: TObject);
    procedure aSelectionToNewBufferUpdate(Sender: TObject);
    procedure ApplicationEventsSettingChange(Sender: TObject; Flag: Integer;
      const Section: string; var Result: Integer);
    procedure aSaveUpdate(Sender: TObject);
    procedure aSaveAsUpdate(Sender: TObject);
    procedure aSaveAllExecute(Sender: TObject);
    procedure aCloseAllExecute(Sender: TObject);
    procedure aCloseAllWithoutSaveExecute(Sender: TObject);
    procedure aCheckASCIIExecute(Sender: TObject);
    procedure ApplicationEventsException(Sender: TObject; E: Exception);
    procedure aLoremIpsumExecute(Sender: TObject);
    procedure aStatusMsgCopyExecute(Sender: TObject);
    procedure aShowAutoReplaceListExecute(Sender: TObject);
    procedure EditorNotification(Sender: TObject; MsgID: Cardinal;
      AClear: Boolean);
    procedure aNotificationWindowUpdate(Sender: TObject);
    procedure aNotificationWindowExecute(Sender: TObject);
    procedure aAdvStatisticsExecute(Sender: TObject);
    procedure aChrFindExecute(Sender: TObject);
    procedure OpenMnuURL(Sender: TObject);
    procedure aItUpperCaseExecute(Sender: TObject);
    procedure aItLowerCaseExecute(Sender: TObject);
    procedure aItSuperscriptExecute(Sender: TObject);
    procedure aItSubscriptExecute(Sender: TObject);
    procedure aItParenthesizedExecute(Sender: TObject);
    procedure aItCircledExecute(Sender: TObject);
    procedure aItDoublyCircledExecute(Sender: TObject);
    procedure aItNoneExecute(Sender: TObject);
    procedure aItUpperCaseUpdate(Sender: TObject);
    procedure aItLowerCaseUpdate(Sender: TObject);
    procedure aItSuperscriptUpdate(Sender: TObject);
    procedure aItSubscriptUpdate(Sender: TObject);
    procedure aItParenthesizedUpdate(Sender: TObject);
    procedure aItCircledUpdate(Sender: TObject);
    procedure aItDoublyCircledUpdate(Sender: TObject);
    procedure aItNoneUpdate(Sender: TObject);
    procedure aInsertCharByDescriptionSearchExecute(Sender: TObject);
  private const
    SYN_XML = 0;
    SYN_HTML = 1;
    SYN_CSS = 2;
    SYN_MW = 3;
    SYN_PAS = 4;
    SYN_AS = 5;
    SYN_INI = 6;
    SYN_HIGH = 6;
  private const
    DEFAULT_ASSOC_XML = 'xml,xsl,svg,rss,atom,xul,wml';
    DEFAULT_ASSOC_HTML = 'xhtml,html,htm,asp,php';
    DEFAULT_ASSOC_CSS = 'css';
    DEFAULT_ASSOC_MW = '';
    DEFAULT_ASSOC_PAS = 'pas,dpr';
    DEFAULT_ASSOC_AS = 'prg';
    DEFAULT_ASSOC_INI = 'ini,inf,url,book,shelf,iss';
  private var
    FFirstTimeChrDlg: boolean;
    FTextFiles: array of TTextFile;
    FSynHighlightAssocs: array[0..SYN_HIGH] of string;
    FReadOnlyAssocs: string;
    FTrimAssocs: string;
    FAutoTip: boolean;
    FFirstActivate: boolean;
    FOldDefaultEffect: TBitmapEffect;
    FDisabledByModality: boolean;
    procedure UpdateTabs;
    procedure SetWindowCaption;
    procedure ShowErrorMessage(const Str: string);
    procedure DoInstantSearch;
    procedure StatusBarCharacterInfo(c: Char);
    function GetSizeGripSize: integer;
    function HasImportantNotification: boolean;
    procedure InsertTags(const TagName: string);
    procedure InsertTag(const TagName: string);
    procedure FontDialogApply(Sender: TObject; Wnd: HWND);
    function SelectColor(var AColor: TColor): boolean;
    procedure ApplyAssocFormattingProcessor;
    procedure ApplyAssocReadOnlyMode;
    procedure EncodingMenuSelect;
    procedure TabsMenuItemClick(Sender: TObject);
    procedure TaskDialogHyperLinkClicked(Sender: TObject);
    procedure TipOfTheDayVerificationClicked(Sender: TObject);
    procedure ShowSettingsDialog(DefaultTab: Integer = 0);
    procedure LoadRTEFile(const AFileName: TFileName);
    procedure LoadSingleInstanceRTEFile(const AFileName: TFileName);
    function GetTrimRight(const AFileName: TFileName): boolean;
    procedure UpdateNotificationsWindow;
    function GetLastNotification: string;
    function GetInitialFileName(const ATextFile: TTextFile): string;
  protected
    procedure WMDropFiles(var Message: TWMDropFiles); message WM_DROPFILES;
    procedure WMExitMenuLoop(var Message: TWMExitMenuLoop);
      message WM_EXITMENULOOP;
  public
    { Public declarations }
    FKeyPressed: boolean;
    FDoAbortPrinting: boolean;
    procedure GotoFile(FileIndex: integer);
    procedure LoadFile(const AFileName: TFileName);
    function CloseFile(FileIndex: integer; CloseApp: boolean = true): boolean;
    function SaveFile(FileIndex: integer): boolean;
    function SaveFileAs(FileIndex: integer): boolean;
    function QueryFileSave(FileIndex: integer): boolean;
    function ActiveFileIndex: integer;
    procedure SaveSettingsToFile;
    procedure LoadSettingsFromFile;
    procedure RestoreDefaultSettings;
    procedure CharacterInfo(const AChar: char);
    function GetHTMLExportFileName: string;
    function GetSettingsFileName: string;
    procedure NewBufferWithContents(const S: string);
  end;

var
  mainFrm: TmainFrm;

const
  STATUS_FILE_POSITION = 0;
  STATUS_OVERWRITE = 1;
  STATUS_MESSAGE = 2;
  STATUS_ZOOM_CONTROL = 3;

implementation

uses Math, Themes, ShellAPI, ShlObj, SHFolder, wwpWin, sortWin, historyWin,
  replaceWin, MultiInput, timeWin, chrWin, UnicodeData, Clipbrd, pasteAsWin,
  StrUtils, ColorDialog, IniFiles, settingsWin, printingWin,
  Printers, selEncWin, statisticsWin, truncateWin, filterWin, RichEdit,
  notificationsWin, advstatisticsWin, chrSearchWin;

{$R *.dfm}

type
  TVerInfo = packed record
    vMajor, vMinor, vRelease, vBuild: word;
  end;

function ExtractFileExt(const S: string): string;
begin
  result := SysUtils.ExtractFileExt(S);
  if result = '' then Exit;
  if result[1] = '.' then Delete(result, 1, 1);
end;

function ItemInList(const Item, List: string): boolean;
var
  i, last: integer;
begin
  result := false;
  if Item = '' then Exit;
  last := 1;
  for i := 1 to Length(List) + 1 do
    if (i = Length(List) + 1) or (List[i] = ',') then
    begin
      if SameText(Item, Trim(Copy(List, last, i - last))) then
        Exit(true);
      last := i + 1;
    end;
end;

function GetFileVerNumbers(const FileName: string): TVerInfo;
var
  len, dummy: cardinal;
  verdata: pointer;
  verstruct: pointer;
const
  InvalidVersion: TVerInfo = (vMajor: 0; vMinor: 0; vRelease: 0; vBuild: 0);
begin
  len := GetFileVersionInfoSize(PWideChar(FileName), dummy);
  if len = 0 then
    Exit(InvalidVersion);
  GetMem(verdata, len);
  try
    GetFileVersionInfo(PWideChar(FileName), 0, len, verdata);
    VerQueryValue(verdata, '\', verstruct, dummy);
    result.vMajor := HiWord(TVSFixedFileInfo(verstruct^).dwFileVersionMS);
    result.vMinor := LoWord(TVSFixedFileInfo(verstruct^).dwFileVersionMS);
    result.vRelease := HiWord(TVSFixedFileInfo(verstruct^).dwFileVersionLS);
    result.vBuild := LoWord(TVSFixedFileInfo(verstruct^).dwFileVersionLS);
  finally
    FreeMem(verdata);
  end;
end;

function GetFileVer(const FileName: string): string;
begin
  with GetFileVerNumbers(FileName) do
    result := IntToStr(vMajor) + '.' + IntToStr(vMinor) + '.' + IntToStr(vRelease) + '.' + IntToStr(vBuild);
end;

procedure TmainFrm.aAboutExecute(Sender: TObject);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'About Rejbrand Text Editor';
        Title := 'Rejbrand Text Editor';
        CommonButtons := [tcbClose];
        Text := 'Application version: ' + GetFileVer(Application.ExeName) + #13#10#13#10'Copyright © 2008–2017 Andreas Rejbrand'#13#10#13#10'<a href="http://english.rejbrand.se">http://english.rejbrand.se</a>';
        Flags := [tfUseHiconMain, tfEnableHyperlinks, tfAllowDialogCancellation];
        FooterText := 'Unicode version: ' + UCDUnicodeVersion;
        CustomMainIcon := Application.Icon;
        OnHyperlinkClicked := TaskDialogHyperlinkClicked;
        ExecuteModally;
      finally
        Free;
      end
  else
    // Windows XP Compatibility Code
    MessageBox(Handle, PChar('File Version: ' + GetFileVer(Application.ExeName) + #13#10#13#10 + 'Copyright © 2008–2017 Andreas Rejbrand' + #13#10#13#10 + 'http://english.rejbrand.se' + #13#10#13#10 + 'Rejbrand Text Editor is running in Windows XP Compatibility Mode.'), PChar('Rejbrand Text Editor'), MB_ICONINFORMATION);
end;

procedure TmainFrm.TaskDialogHyperLinkClicked(Sender: TObject);
begin
  if Sender is TTaskDialog then
    with Sender as TTaskDialog do
      ShellExecute(Handle, 'open', PChar(URL), nil, nil, SW_SHOWNORMAL);
end;

procedure TmainFrm.aAddIndentExecute(Sender: TObject);
begin
  Editor.AddIndent;
end;

function TabChecker(C: char): boolean;
begin
  result := C = #9;
end;

procedure TmainFrm.aAdvStatisticsExecute(Sender: TObject);
var
  counts: TIntegerArray;
  i, c1, c2, c3: integer;
begin
  with TadvstatisticsFrm.Create(nil) do
    try
      Screen.Cursor := crHourGlass;
      try
        eStats.LoadDefaultClasses;
        eStats.MultiSize := true;
        eStats.AddClass(MakeClass('Empty block', 12, [], clWindowText));
        if GetSysColor(COLOR_WINDOW) = clWhite then
        begin
          eStats.AddClass(MakeClass('Nonempty block', 12, [fsBold], clNavy));
          eStats.AddClass(MakeClass('Beyond BMP', 12, [fsItalic], clGray));
        end
        else
          eStats.AddClass(MakeClass('Nonempty block', 12, [fsBold], clWindowText));
          eStats.AddClass(MakeClass('Beyond BMP', 12, [fsItalic], clWindowText));
        eStats.BeginAddLine;
        counts := Editor.TextFile.GetUnicodeBlockStatistics;
        eStats.AddLine('Unicode blocks', 'Heading 1');
        for i := 0 to Length(counts) - 1 do
          eStats.AddLine(
            UCD.Blocks[i].BlockName +
            DupeString('.', 48 - Length(UCD.Blocks[i].BlockName)) +
            IntToStr(counts[i]),
            IfThen(counts[i] > 0, 'Nonempty block',
              IfThen(UCD.Blocks[i].BlockBegin > $FFFF, 'Beyond BMP', 'Empty block')
            ));

        eStats.AddLine;
        eStats.AddLine('Special characters', 'Heading 1');
        c1 := Editor.TextFile.GetControlCharCount;
        c2 := Editor.TextFile.GetNoncharacterCount;
        c3 := Editor.TextFile.NumCharsOfType(TabChecker);

        eStats.AddLine(
          'Control characters' +
          DupeString('.', 48 - Length('Control characters')) +
          IntToStr(c1),
          IfThen(c1 > 0, 'Nonempty block', 'Empty block'));

        if c1 > 0 then
          eStats.AddLine(
            '... of which are CT (U+0009)' +
            DupeString('.', 48 - Length('... of which are CT (U+0009)')) +
            IntToStr(c3),
            IfThen(c3 > 0, 'Nonempty block', 'Empty block'));

        eStats.AddLine(
          'Noncharacters' +
          DupeString('.', 48 - Length('Noncharacters')) +
          IntToStr(c2),
          IfThen(c2 > 0, 'Nonempty block', 'Empty block'));

        eStats.EndAddLine;
        eStats.EditMode := emReadOnly;
        eStats.TextFile.StrictReadOnly := true;
        eStats.TextFile.UseLineClasses := true;
        eStats.TextFile.GotoSOF;
      finally
        Screen.Cursor := crDefault;
      end;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TmainFrm.aAutoIndentExecute(Sender: TObject);
begin
  Editor.AutoIndent := not Editor.AutoIndent;
end;

procedure TmainFrm.aAutoIndentUpdate(Sender: TObject);
begin
  aAutoIndent.Checked := Editor.AutoIndent;
end;

procedure TmainFrm.aAutoReplaceExecute(Sender: TObject);
begin
  Editor.AutoReplace := not Editor.AutoReplace;
end;

procedure TmainFrm.aAutoReplaceUpdate(Sender: TObject);
begin
  aAutoReplace.Checked := Editor.AutoReplace;
end;

procedure TmainFrm.aBracketHighlightExecute(Sender: TObject);
begin
  Editor.MatchBrackets := not Editor.MatchBrackets;
end;

procedure TmainFrm.aBracketHighlightUpdate(Sender: TObject);
begin
  aBracketHighlight.Checked := Editor.MatchBrackets;
end;

procedure TmainFrm.TabsMenuOpen(Sender: TObject);
var
  i: Integer;
  mnuItem: TMenuItem;
begin

  for i := mnuTabs.Count - 1 downto 0 do
    with mnuTabs.Items[i] do
      if (Action = nil) and (Caption <> '-') then
        mnuTabs.Delete(i);

  for i := 0 to high(FTextFiles) do
  begin
    mnuItem := TMenuItem.Create(mnuTabs);
    with mnuItem do
    begin
      Caption := ExtractFileName(FTextFiles[i].FileName) + IfThen(FTextFiles[i].FileModified, ' *');
      Tag := i;
      Hint := FTextFiles[i].FileName + IfThen(FTextFiles[i].FileModified, ' (modified)');
      Checked := ActiveFileIndex = i;
      OnClick := TabsMenuItemClick;
    end;
    mnuTabs.Add(mnuItem);
  end;

end;

procedure TmainFrm.TabsMenuItemClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    GotoFile(TMenuItem(Sender).Tag);
end;

procedure TmainFrm.aCaesarExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_CAESAR);
end;

procedure TmainFrm.aCaesarUpdate(Sender: TObject);
begin
  aCaesar.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_CAESAR);
end;

procedure TmainFrm.aCamelCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_CAMEL_CASE);
end;

procedure TmainFrm.aCamelCaseUpdate(Sender: TObject);
begin
  aCamelCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_CAMEL_CASE);
end;

procedure TmainFrm.aCaretBeyondEOLExecute(Sender: TObject);
begin
  Editor.CaretAfterEOL := not Editor.CaretAfterEOL;
end;

procedure TmainFrm.aCaretBeyondEOLUpdate(Sender: TObject);
begin
  aCaretBeyondEOL.Checked := Editor.CaretAfterEOL;
end;

procedure TmainFrm.aCheckASCIIExecute(Sender: TObject);
var
  y: Integer;
  x: Integer;
begin
  for y := 0 to Editor.LineCount - 1 do
    for x := 0 to Editor.TextFile.VirtualLineWidths[y] - 1 do
      if ord(Editor.TextFile.Character[Y, X]) > 127 then
      begin
        Editor.TextFile.CaretPos.CreateSelection(Point(X, Y), Point(X+1, Y));
        MessageBox(Handle, 'The text contains non-ASCII characters.',
          PChar(ExtractFileName(Editor.TextFile.FileName)), MB_ICONINFORMATION or MB_OK);
        Exit;
      end;

  MessageBox(Handle, 'The text contains only ASCII characters.',
    PChar(ExtractFileName(Editor.TextFile.FileName)), MB_ICONINFORMATION or MB_OK);
end;

procedure TmainFrm.aChrFindExecute(Sender: TObject);
begin
  with TchrSearchFrm.Create(nil) do
    try
      if ShowModal = mrOk then
        if rbNonASCII.Checked then
          Editor.Find(MakeFindQuery(FQ_NONASCII))
        else if rbControl.Checked then
          Editor.Find(MakeFindQuery(FQ_CONTROL))
        else if rbNonchars.Checked then
          Editor.Find(MakeFindQuery(FQ_NONCHAR))
        else if rbBlock.Checked then
          Editor.Find(MakeFindQuery(lbBlocks.ItemIndex + 1));
    finally
      Free;
    end;
end;

procedure TmainFrm.aClearExecute(Sender: TObject);
begin
  Editor.ClearSelection;
end;

procedure TmainFrm.aClearLineExecute(Sender: TObject);
begin
  Editor.ClearLine;
end;

procedure TmainFrm.aClearLineUpdate(Sender: TObject);
begin
  aClearLine.Enabled := Editor.TextFile.PhysicalLineWidths[Editor.CaretPos.Y] > 0;
end;

procedure TmainFrm.aClearUpdate(Sender: TObject);
begin
  aClear.Enabled := Editor.Focused and Editor.TextFile.HasSelection;
end;

procedure TmainFrm.aCloseAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := high(FTextFiles) downto 0 do
    if not CloseFile(i, false) then Exit;
end;

procedure TmainFrm.aCloseAllWithoutSaveExecute(Sender: TObject);
var
  i: Integer;
begin

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := 'Are you sure that you want to close all files (tabs) without saving the changes made to them (if any)?';
        Text := 'All changes will be lost. This operation cannot be undone.';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Yes, close all without saving';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&No, cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiWarning;
        if ExecuteModally then
          if ModalResult <> mrYes then
            Exit;
      finally
        Free;
      end
  else
    if MessageBox(Handle,
      'Are you sure that you want to close all files (tabs) without saving the changes made to them (if any)?',
      'Rejbrand Text Editor',
      MB_ICONWARNING or MB_YESNOCANCEL) <> ID_YES then
        Exit;

  for i := 0 to high(FTextFiles) do
    FTextFiles[i].FileModified := false;

  aCloseAll.Execute;
end;

procedure TmainFrm.aCloseExecute(Sender: TObject);
begin
  CloseFile(ActiveFileIndex);
end;

procedure TmainFrm.aCustomDateTimeExecute(Sender: TObject);
begin
  with TtimeFrm.Create(nil) do
    try
      if (ShowModal = mrOk) and (lbFormats.ItemIndex <> -1) then
        Editor.SelText := lbFormats.Items[lbFormats.ItemIndex];
    finally
      Free;
    end;
end;

procedure TmainFrm.aCutExecute(Sender: TObject);
begin
  Editor.CutToClipboard;
end;

procedure TmainFrm.aCutUpdate(Sender: TObject);
begin
  aCut.Enabled := Editor.Focused and Editor.TextFile.HasSelection;
end;

procedure TmainFrm.aDateTimeExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_WRITE_DATETIME);
end;

procedure TmainFrm.aDeleteFileExecute(Sender: TObject);

  procedure DoDeleteFile;
  begin
    if DeleteFile(Editor.TextFile.FileName) then
    begin
      Editor.TextFile.FileModified := true;
      UpdateTabs;
      SetWindowCaption;
    end
    else
      ShowErrorMessage(Format('An error occurred while trying to delete the file "%s".',
        [ExtractFileName(Editor.TextFile.FileName)]));
  end;

begin
  if not FileExists(Editor.TextFile.FileName) then
    Exit;

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(Editor.TextFile.FileName);
        Text := 'Do you want to delete this file from the file system?';
        FooterText := 'The text will still be available in the editor.';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Delete';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              DoDeleteFile;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to delete this file from the file system?',
        PChar(ExtractFileName(Editor.TextFile.FileName)),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        DoDeleteFile;
    end;
end;

procedure TmainFrm.aDeleteFileUpdate(Sender: TObject);
begin
  aDeleteFile.Enabled := FileExists(Editor.TextFile.FileName) and
    not Editor.TextFile.StrictReadOnly;
end;

procedure TmainFrm.aDuplicateBufferExecute(Sender: TObject);
begin
  NewBufferWithContents(Editor.PlainText);
end;

procedure TmainFrm.aEncANSIExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teWindows8bitCodepage);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncANSIUpdate(Sender: TObject);
begin
  aEncANSI.Checked := Editor.TextFile.Encoding.TextEncoding = teWindows8bitCodepage;
end;

procedure TmainFrm.aEncASCIIExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teASCII);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncASCIIUpdate(Sender: TObject);
begin
  aEncASCII.Checked := Editor.TextFile.Encoding.TextEncoding = teASCII;
end;

procedure TmainFrm.aEncCRLFExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetLineBreakType(lbtCRLF);
end;

procedure TmainFrm.aEncCRLFUpdate(Sender: TObject);
begin
  aEncCRLF.Checked := Editor.TextFile.Encoding.LineBreakType = lbtCRLF;
end;

procedure TmainFrm.aEncLFExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetLineBreakType(lbtLF);
end;

procedure TmainFrm.aEncLFUpdate(Sender: TObject);
begin
  aEncLF.Checked := Editor.TextFile.Encoding.LineBreakType = lbtLF;
end;

procedure TmainFrm.aEncMagicBytesExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetMagicWord(not Editor.TextFile.Encoding.MagicWord);
end;

procedure TmainFrm.aEncMagicBytesUpdate(Sender: TObject);
begin
  aEncMagicBytes.Checked := Editor.TextFile.Encoding.MagicWord;
end;

procedure TmainFrm.aEncUTF16BEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF16BE);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncUTF16BEUpdate(Sender: TObject);
begin
  aEncUTF16BE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF16BE;
end;

procedure TmainFrm.aEncUTF16LEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF16LE);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncUTF16LEUpdate(Sender: TObject);
begin
  aEncUTF16LE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF16LE;
end;

procedure TmainFrm.aEncUTF32BEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF32BE);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncUTF32BEUpdate(Sender: TObject);
begin
  aEncUTF32BE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF32BE;
end;

procedure TmainFrm.aEncUTF32LEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF32LE);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncUTF32LEUpdate(Sender: TObject);
begin
  aEncUTF32LE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF32LE;
end;

procedure TmainFrm.aEncUTF8Execute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF8);
  EncodingMenuSelect;
end;

procedure TmainFrm.aEncUTF8Update(Sender: TObject);
begin
  aEncUTF8.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF8;
end;

procedure TmainFrm.aExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TmainFrm.aFillWithcharExecute(Sender: TObject);
var
  v: char;
begin
  v := 'A';
  if TMultiInputBox.CharInputBox(Self, 'Fill with character',
    'Please enter the character to fill the selection with:', v) then
    Editor.FillWithChar(v)
end;

procedure TmainFrm.aFillWithcharUpdate(Sender: TObject);
begin
  aFillWithchar.Enabled := Editor.TextFile.HasSelection;
end;

procedure TmainFrm.aFilterExecute(Sender: TObject);
begin
  with TfilterFrm.Create(nil) do
    try
      if ShowModal = mrOk then
        Editor.Filter(eContains.Text, eStarts.Text, eEnds.Text,
          cbCaseSensitive.Checked, rbRemove.Checked);
    finally
      Free;
    end;
end;

procedure TmainFrm.aFindExecute(Sender: TObject);
begin
  pnSearch.Show;
  if TabList.Visible then
    TabList.Top := 0;
  if eFind.CanFocus then
  begin
    eFind.SetFocus;
    eFind.SelectAll;
  end;
end;

procedure TmainFrm.aFindNextExecute(Sender: TObject);
begin
  Editor.FindNext;
end;

procedure TmainFrm.aFindNextUpdate(Sender: TObject);
begin
  aFindNext.Enabled := Editor.TextFile.FindCount > 0;
end;

procedure TmainFrm.aFindPrevExecute(Sender: TObject);
begin
  Editor.FindPrevious;
end;

procedure TmainFrm.aFindPrevUpdate(Sender: TObject);
begin
  aFindPrev.Enabled := Editor.TextFile.FindCount > 0;
end;

procedure TmainFrm.FontDialogApply(Sender: TObject; Wnd: HWND);
begin
  if Sender is TFontDialog then
    Editor.Font.Assign(TFontDialog(Sender).Font);
end;

procedure TmainFrm.aFontExecute(Sender: TObject);
begin
  with TFontDialog.Create(nil) do
    try
      Font.Assign(Editor.Font);
      Options := [fdFixedPitchOnly, fdForceFontExist, fdApplyButton];
      OnApply := FontDialogApply;
      if Execute then
        Editor.Font.Assign(Font);
    finally
      Free;
    end;
end;

procedure TmainFrm.aFPASExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := AlgoSimFormattingProcessor1;
end;

procedure TmainFrm.aFPASUpdate(Sender: TObject);
begin
  aFPAS.Checked := Editor.FormattingProcessor = AlgoSimFormattingProcessor1;
end;

procedure TmainFrm.aFPCSSExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := CSSFormattingProcessor1;
end;

procedure TmainFrm.aFPCSSUpdate(Sender: TObject);
begin
  aFPCSS.Checked := Editor.FormattingProcessor = CSSFormattingProcessor1;
end;

procedure TmainFrm.aFPHTMLExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := HTMLFormattingProcessor1;
end;

procedure TmainFrm.aFPHTMLUpdate(Sender: TObject);
begin
  aFPHTML.Checked := Editor.FormattingProcessor = HTMLFormattingProcessor1;
end;

procedure TmainFrm.aFPINIExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := INIFormattingProcessor1;
end;

procedure TmainFrm.aFPINIUpdate(Sender: TObject);
begin
  aFPINI.Checked := Editor.FormattingProcessor = INIFormattingProcessor1;
end;

procedure TmainFrm.aFPMWExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := MediaWikiFormattingProcessor1;
end;

procedure TmainFrm.aFPMWUpdate(Sender: TObject);
begin
  aFPMW.Checked := Editor.FormattingProcessor = MediaWikiFormattingProcessor1;
end;

procedure TmainFrm.aFPNoneExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := nil;
end;

procedure TmainFrm.aFPNoneUpdate(Sender: TObject);
begin
  aFPNone.Checked := Editor.FormattingProcessor = nil;
end;

procedure TmainFrm.aFPPascalExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := PascalFormattingProcessor1;
end;

procedure TmainFrm.aFPPascalUpdate(Sender: TObject);
begin
  aFPPascal.Checked := Editor.FormattingProcessor = PascalFormattingProcessor1;
end;

procedure TmainFrm.aFPXMLExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := XMLFormattingProcessor1;
end;

procedure TmainFrm.aFPXMLUpdate(Sender: TObject);
begin
  aFPXML.Checked := Editor.FormattingProcessor = XMLFormattingProcessor1;
end;

procedure TmainFrm.aGoToExecute(Sender: TObject);
var
  v: integer;
begin
  v := Editor.CaretPos.Y + 1;
  if TMultiInputBox.NumInputBox(Self,
    'Go to', 'Please enter a line number to go to:', v, 1, Editor.LineCount) then
    Editor.CaretPos := Point(0, v - 1);
end;

function GetDriveAccess: string;
var
  path: array [0..MAX_PATH] of char;
begin
  SHGetFolderPath(0, CSIDL_APPDATA, 0, SHGFP_TYPE_CURRENT, @path);
  result := path + '\Rejbrand\Rejbrand Text Editor\3.0\';
  ForceDirectories(result);
end;

function TmainFrm.GetHTMLExportFileName: string;
begin
  result := GetDriveAccess + 'export.html';
end;

procedure TmainFrm.aHelpExecute(Sender: TObject);
begin
  LoadSingleInstanceRTEFile(ExtractFilePath(Application.ExeName) + 'Help.rte');
end;

procedure TmainFrm.aHiddenCharsExecute(Sender: TObject);
begin
  Editor.ShowHiddenCharacters := not Editor.ShowHiddenCharacters;
end;

procedure TmainFrm.aHiddenCharsUpdate(Sender: TObject);
begin
  aHiddenChars.Checked := Editor.ShowHiddenCharacters;
end;

procedure TmainFrm.aHistoryExecute(Sender: TObject);
var
  i: integer;
begin
  Editor.TypeTimerEnd;
  with ThistoryFrm.Create(nil) do
    try
      lvHistory.Items.BeginUpdate;
      for i := Editor.TextFile.HistoryManager.FirstItem to Editor.TextFile.HistoryManager.LastItem do
        with lvHistory.Items.Add, Editor.TextFile.HistoryManager.UndoData[i] do
        begin
          Caption := IntToStr(i + 1);
          SubItems.Add(DateTimeToStr(Time));
          Subitems.Add(IntToStr(Length(Text)));
          SubItems.Add(Comment);
        end;
      lvHistory.Items.EndUpdate;
      lvHistory.ItemIndex := Editor.TextFile.HistoryManager.HistoryIndex - Editor.TextFile.HistoryManager.FirstItem;

      StatusBar1.SimplePanel := true;
      StatusBar1.SimpleText := Format('%d item(s), %s in total',
        [Editor.TextFile.HistoryManager.Count,
         FormatDataSize(Editor.TextFile.HistoryManager.Size)]);
      ShowModal;
    finally
      Free;
    end;
end;

procedure TmainFrm.aHTMLBExecute(Sender: TObject);
begin
  InsertTags('b');
end;

procedure TmainFrm.aHTMLBrExecute(Sender: TObject);
begin
  InsertTag('br');
end;

procedure TmainFrm.aHTMLDivExecute(Sender: TObject);
begin
  InsertTags('div');
end;

procedure TmainFrm.aHTMLEMExecute(Sender: TObject);
begin
  InsertTags('em');
end;

procedure TmainFrm.aHTMLExportExecute(Sender: TObject);
var
  S: string;
begin
  S := GetHTMLExportFileName;
  Editor.ExportToHTML(S);
  LoadFile(S);
end;

procedure TmainFrm.aHTMLH1Execute(Sender: TObject);
begin
  InsertTags('h1');
end;

procedure TmainFrm.aHTMLH2Execute(Sender: TObject);
begin
  InsertTags('h2');
end;

procedure TmainFrm.aHTMLH3Execute(Sender: TObject);
begin
  InsertTags('h3');
end;

procedure TmainFrm.aHTMLH4Execute(Sender: TObject);
begin
  InsertTags('h4');
end;

procedure TmainFrm.aHTMLH5Execute(Sender: TObject);
begin
  InsertTags('h5');
end;

procedure TmainFrm.aHTMLH6Execute(Sender: TObject);
begin
  InsertTags('h6');
end;

procedure TmainFrm.aHTMLIExecute(Sender: TObject);
begin
  InsertTags('i');
end;

procedure TmainFrm.aHTMLLIExecute(Sender: TObject);
begin
  InsertTags('li');
end;

procedure TmainFrm.aHTMLnbspExecute(Sender: TObject);
begin
  Editor.SelText := '&nbsp;';
end;

procedure TmainFrm.aHTMLOLExecute(Sender: TObject);
begin
  InsertTags('ol');
end;

procedure TmainFrm.aHTMLPExecute(Sender: TObject);
begin
  InsertTags('p');
end;

procedure TmainFrm.aHTMLspanExecute(Sender: TObject);
begin
  InsertTags('span');
end;

procedure TmainFrm.aHTMLstrongExecute(Sender: TObject);
begin
  InsertTags('strong');
end;

procedure TmainFrm.aHTMLtableExecute(Sender: TObject);
begin
  InsertTags('table');
end;

procedure TmainFrm.aHTMLtdExecute(Sender: TObject);
begin
  InsertTags('td');
end;

procedure TmainFrm.aHTMLthExecute(Sender: TObject);
begin
  InsertTags('th');
end;

procedure TmainFrm.aHTMLtrExecute(Sender: TObject);
begin
  InsertTags('tr');
end;

procedure TmainFrm.aHTMLUExecute(Sender: TObject);
begin
  InsertTags('u');
end;

procedure TmainFrm.aHTMLULExecute(Sender: TObject);
begin
  InsertTags('ul');
end;

procedure TmainFrm.InsertTags(const TagName: string);
begin
  Editor.SurroundText('<' + TagName + '>', '</' + TagName + '>');
end;

procedure TmainFrm.InsertTag(const TagName: string);
begin
  Editor.SelText := '<' + TagName + ' />';
end;

procedure TmainFrm.aInsertCharByDescriptionSearchExecute(Sender: TObject);
begin
  if not chrFrm.Visible then
    aInsertChar.Execute;
  chrFrm.Searchforstring1.Click;
end;

procedure TmainFrm.aInsertCharExecute(Sender: TObject);
begin

  if FFirstTimeChrDlg then
  begin
    if (WindowState = wsNormal) and (Left + Width + chrFrm.Width <= Screen.DesktopWidth) then
    begin
      chrFrm.Top := Top + Height - chrFrm.Height;
      chrFrm.Left := Left + Width;
    end
    else if WindowState = wsMaximized then
    begin
      chrFrm.Top := Top + Height - chrFrm.Height - IfThen(StatusBar.Visible, StatusBar.Height) - GetSystemMetrics(SM_CYFRAME) - 16;
      chrFrm.Left := Left + Width - chrFrm.Width - 16;
    end;
  end;

  chrFrm.Show;

  if chrFrm.CanFocus then
    chrFrm.SetFocus;

  FFirstTimeChrDlg := false;
end;

procedure TmainFrm.aInsertColorExecute(Sender: TObject);
begin
  with ColorDialog.TColorDialog.Create(nil) do
    try
      if (Editor.SelLength = 7) and (Editor.SelText[1] = '#') then
        ColorAsHex := Editor.SelText;
      if Execute then
        Editor.SelText := ColorAsHex;
    finally
      Free;
    end;
end;

procedure TmainFrm.aInvertCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_INVERT_CASE);
end;

procedure TmainFrm.aInvertCaseUpdate(Sender: TObject);
begin
  aInvertCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_INVERT_CASE);
end;

procedure TmainFrm.aItCircledExecute(Sender: TObject);
begin
  Editor.InputTransform := itCircled;
end;

procedure TmainFrm.aItCircledUpdate(Sender: TObject);
begin
  aItCircled.Checked := Editor.InputTransform = itCircled;
end;

procedure TmainFrm.aItDoublyCircledExecute(Sender: TObject);
begin
  Editor.InputTransform := itDoublyCircled;
end;

procedure TmainFrm.aItDoublyCircledUpdate(Sender: TObject);
begin
  aItDoublyCircled.Checked := Editor.InputTransform = itDoublyCircled;
end;

procedure TmainFrm.aItLowerCaseExecute(Sender: TObject);
begin
  Editor.InputTransform := itLowerCase;
end;

procedure TmainFrm.aItLowerCaseUpdate(Sender: TObject);
begin
  aItLowerCase.Checked := Editor.InputTransform = itLowerCase;
end;

procedure TmainFrm.aItNoneExecute(Sender: TObject);
begin
  Editor.InputTransform := itNone;
end;

procedure TmainFrm.aItNoneUpdate(Sender: TObject);
begin
  aItNone.Checked := Editor.InputTransform = itNone;
end;

procedure TmainFrm.aItParenthesizedExecute(Sender: TObject);
begin
  Editor.InputTransform := itParenthesized;
end;

procedure TmainFrm.aItParenthesizedUpdate(Sender: TObject);
begin
  aItParenthesized.Checked := Editor.InputTransform = itParenthesized;
end;

procedure TmainFrm.aItSubscriptExecute(Sender: TObject);
begin
  Editor.InputTransform := itSubscript;
end;

procedure TmainFrm.aItSubscriptUpdate(Sender: TObject);
begin
  aItSubscript.Checked := Editor.InputTransform = itSubscript;
end;

procedure TmainFrm.aItSuperscriptExecute(Sender: TObject);
begin
  Editor.InputTransform := itSuperscript;
end;

procedure TmainFrm.aItSuperscriptUpdate(Sender: TObject);
begin
  aItSuperscript.Checked := Editor.InputTransform = itSuperscript;
end;

procedure TmainFrm.aItUpperCaseExecute(Sender: TObject);
begin
  Editor.InputTransform := itUpperCase;
end;

procedure TmainFrm.aItUpperCaseUpdate(Sender: TObject);
begin
  aItUpperCase.Checked := Editor.InputTransform = itUpperCase;
end;

const
  LoremIpsum: array[0..3] of string = ('Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ',
    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. ',
    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. ',
    'Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. ');

procedure TmainFrm.aLoremIpsumExecute(Sender: TObject);
var
  N: integer;
  S: string;
  i: Integer;
begin
  N := 4;
  S := '';
  if TMultiInputBox.NumInputBox(Self, 'Lorem ipsum', 'Please enter the number of sentences to insert:', N, 1, 1024) then
  begin
    for i := 0 to N - 1 do
      S := S + LoremIpsum[i mod 4];
    Editor.SelText := S;
  end;
end;

procedure TmainFrm.aLowerCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_LOWER_CASE);
end;

procedure TmainFrm.aLowerCaseUpdate(Sender: TObject);
begin
  aLowerCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_LOWER_CASE);
end;

procedure TmainFrm.aMakeUniqueExecute(Sender: TObject);
begin
  Editor.MakeLinesUnique;
end;

procedure TmainFrm.aMakeUniqueUpdate(Sender: TObject);
begin
  aMakeUnique.Enabled := Editor.LineCount > 1;
end;

procedure TmainFrm.aNewExecute(Sender: TObject);
begin
  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;
  FTextFiles[high(FTextFiles)].NewFileAndInitUndo;
  UpdateTabs;
  GotoFile(high(FTextFiles));
end;

procedure TmainFrm.aNextTabExecute(Sender: TObject);
begin
  if TabList.Items.Count > 0 then
    GotoFile((ActiveFileIndex + 1) mod TabList.Items.Count);
end;

procedure TmainFrm.aNextTabUpdate(Sender: TObject);
begin
  aNextTab.Enabled := TabList.Items.Count > 1;
end;

procedure TmainFrm.aNotificationWindowExecute(Sender: TObject);
begin
  notificationsFrm.Visible := not notificationsFrm.Visible;
  if notificationsFrm.Visible then
    UpdateNotificationsWindow;
end;

procedure TmainFrm.aNotificationWindowUpdate(Sender: TObject);
begin
  aNotificationWindow.Checked := notificationsFrm.Visible;
end;

function GetFileSizeEx(AFile: THandle; var AFileSize: TLargeInteger): BOOL; stdcall; external kernel32;

function GetFileSize(const AFileName: TFileName): Int64;
var
  F: THandle;
  S: TLargeInteger;
begin
  result := -1;

  F := CreateFile(PChar(AFileName), GENERIC_READ,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);

  if F = INVALID_HANDLE_VALUE then Exit;

  if GetFileSizeEx(F, S) then
    result := S;

  CloseHandle(F);

end;

procedure TmainFrm.LoadFile(const AFileName: TFileName);
var
  hresult: boolean;
  PositiveEncoding: TTextEncoding;
  PossibleEncodings: TTextEncodings;
  MagicWordsFound: TTextEncodings;
begin

  if not FileExists(AFileName) then
  begin
    ShowErrorMessage(Format('Couldn''t find file "%s".', [AFileName]));
    Exit;
  end;

  if GetFileSize(AFileName) > FILE_SIZE_LIMIT then
  begin
    ShowErrorMessage('The file is too big to load.');
    Exit;
  end;

  hresult := GuessEncodingOfFile(AFileName, PositiveEncoding, PossibleEncodings, MagicWordsFound);
  if hresult then
  begin
    SetLength(FTextFiles, Length(FTextFiles) + 1);
    FTextFiles[high(FTextFiles)] := TTextFile.Create;
    Screen.Cursor := crHourGlass;
    try
      FTextFiles[high(FTextFiles)].LoadFromFileAndInitUndo(AFileName, GetVCLEncoding(PositiveEncoding));
    finally
      Screen.Cursor := crDefault;
    end;
  end
  else
    with TselEncFrm.Create(nil) do
      try
        FFileName := AFileName;
        FPossibleEncodings := PossibleEncodings;
        FProbableEncoding := PositiveEncoding;
        if ShowModal = mrOk then
        begin
          SetLength(FTextFiles, Length(FTextFiles) + 1);
          FTextFiles[high(FTextFiles)] := TTextFile.Create;
          Screen.Cursor := crHourGlass;
          try
            FTextFiles[high(FTextFiles)].LoadFromFileAndInitUndo(AFileName, GetVCLEncoding(FSelectedEncoding));
          finally
            Screen.Cursor := crDefault;
          end;
        end
        else
          Exit;
      finally
        Free;
      end;

  FTextFiles[high(FTextFiles)].Encoding.SetHasMagicWord(MagicWordsFound);
  UpdateTabs;
  GotoFile(high(FTextFiles));
  ApplyAssocFormattingProcessor;
  ApplyAssocReadOnlyMode;
end;

procedure TmainFrm.LoadRTEFile(const AFileName: TFileName);
begin
  if not FileExists(AFileName) then
  begin
    ShowErrorMessage(Format('Couldn''t find file "%s".', [AFileName]));
    Exit;
  end;

  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;
  FTextFiles[high(FTextFiles)].LoadFromFile(AFileName, TEncoding.UTF8, true);
  FTextFiles[high(FTextFiles)].StrictReadOnly := true;
  FTextFiles[high(FTextFiles)].UseLineClasses := true;
  with FTextFiles[high(FTextFiles)].EditorState do
  begin
    Valid := true;
    MultiSize := true;
    RulerVisible := false;
  end;

  Editor.LoadDefaultClasses;

  UpdateTabs;
  GotoFile(high(FTextFiles));
  Editor.EditMode := emReadOnly;
end;

procedure TmainFrm.aOpenExecute(Sender: TObject);
begin
  with TOpenDialog.Create(nil) do
    try
      if Execute then
        LoadFile(FileName);
    finally
      Free;
    end;
end;

const
  OFASI_EDIT = $0001;
  OFASI_OPENDESKTOP = $0002;

{$IFDEF UNICODE}
function ILCreateFromPath(pszPath: PChar): PItemIDList stdcall; external shell32
  name 'ILCreateFromPathW';
{$ELSE}
function ILCreateFromPath(pszPath: PChar): PItemIDList stdcall; external shell32
  name 'ILCreateFromPathA';
{$ENDIF}
procedure ILFree(pidl: PItemIDList) stdcall; external shell32;
function SHOpenFolderAndSelectItems(pidlFolder: PItemIDList; cidl: Cardinal;
  apidl: pointer; dwFlags: DWORD): HRESULT; stdcall; external shell32;

procedure TmainFrm.aOpenFolderExecute(Sender: TObject);
var
  IIDL: PItemIDList;
begin
  if not FileExists(Editor.TextFile.FileName) then
    Exit;

  IIDL := ILCreateFromPath(PChar(Editor.TextFile.FileName));
  if IIDL <> nil then
    try
      if SHOpenFolderAndSelectItems(IIDL, 0, nil, 0) <> S_OK then
        ShellExecute(Handle, nil, PChar(ExtractFilePath(Editor.TextFile.FileName)),
          nil, nil, SW_SHOWNORMAL);
    finally
      ILFree(IIDL);
    end;
end;

procedure TmainFrm.aOpenFolderUpdate(Sender: TObject);
begin
  aOpenFolder.Enabled := FileExists(Editor.TextFile.FileName);
end;

procedure TmainFrm.aPasteAsExecute(Sender: TObject);
begin
  with TpasteAsFrm.Create(nil) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TmainFrm.aPasteAsUpdate(Sender: TObject);
begin
  aPasteAs.Enabled := Editor.Focused and Clipboard.HasFormat(CF_TEXT);
end;

procedure TmainFrm.aPasteExecute(Sender: TObject);
begin
  if Editor.Focused then
    Editor.PasteFromClipboard
  else if pnSearch.Visible and eFind.Focused then
    eFind.PasteFromClipboard;
end;

procedure TmainFrm.aPasteUpdate(Sender: TObject);
begin
  aPaste.Enabled := (Editor.Focused and Clipboard.HasFormat(CF_TEXT))
    or (pnSearch.Visible and eFind.Focused and Clipboard.HasFormat(CF_TEXT));
end;

procedure TmainFrm.aPerformWordWrapExecute(Sender: TObject);
begin
  with TwwpFrm.Create(nil) do
    try
      if ShowModal = mrOk then
        if rbN.Checked then
          Editor.WordWrap(StrToInt(eL.Text), cbS.Checked, #0)
        else if rbA.Checked then
          Editor.WordWrap(StrToInt(eL.Text), cbS.Checked, rbA.Caption[1])
        else if (rbC.Checked and (Length(eC.Text) > 0)) then
          Editor.WordWrap(StrToInt(eL.Text), cbS.Checked, eC.Text[1]);
    finally
      Free;
    end;
end;

procedure TmainFrm.aPerformWordWrapUpdate(Sender: TObject);
begin
  aPerformWordWrap.Enabled := not Editor.TextFile.Empty;
end;

procedure TmainFrm.aPrevTabExecute(Sender: TObject);
begin
  if ActiveFileIndex > 0 then
    GotoFile(ActiveFileIndex - 1)
  else
    GotoFile(TabList.Items.Count - 1);
end;

procedure TmainFrm.aPrevTabUpdate(Sender: TObject);
begin
  aPrevTab.Enabled := TabList.Items.Count > 1;
end;

procedure TmainFrm.aPrinterSetupExecute(Sender: TObject);
begin
  with TPrinterSetupDialog.Create(nil) do
    try
      Execute
    finally
      Free;
    end;
end;

procedure TmainFrm.aPrintExecute(Sender: TObject);
begin
  with TPrintDialog.Create(nil) do
    try
      if Editor.TextFile.HasSelection then
        Options := [poSelection];
      if Execute then
        if PrintRange = prSelection then
          Editor.PrintSelection
        else
          Editor.Print
    finally
      Free;
    end;
end;

procedure TmainFrm.aReadOnlyExecute(Sender: TObject);
begin
  if Editor.EditMode = emReadOnly then
    Editor.EditMode := emText
  else
    Editor.EditMode := emReadOnly;
end;

procedure TmainFrm.aReadOnlyUpdate(Sender: TObject);
begin
  aReadOnly.Checked := Editor.EditMode = emReadOnly;
  aReadOnly.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SET_EDIT_MODE);
end;

procedure TmainFrm.aRedoExecute(Sender: TObject);
begin
  Editor.Redo;
end;

procedure TmainFrm.aRedoUpdate(Sender: TObject);
begin
  aRedo.Enabled := Editor.Focused and Editor.CanRedo;
end;

procedure TmainFrm.aRemoveIndentExecute(Sender: TObject);
begin
  Editor.RemoveIndent;
end;

procedure TmainFrm.aReplaceExecute(Sender: TObject);
var
  num: integer;
begin
  with TreplaceFrm.Create(nil) do
    try
      rbSelection.Enabled := Editor.TextFile.HasSelection;
      if rbSelection.Enabled then
        rbSelection.Checked := true
      else
        rbEntireFile.Checked := true;
      if ShowModal = mrOk then
      begin
        Screen.Cursor := crHourglass;
        try
          num := Editor.ReplaceAll(
            MakeFindQuery(eSearch.Text,
              cbMatchCase.Checked,
              cbWWO.Checked,
              cbLF.Checked),
            eReplace.Text, rbSelection.Checked);
        finally
          Screen.Cursor := crDefault;
        end;
        if num = 0 then
          MessageBox(Handle,
            'The search text was not found; the file has not been changed.',
            PChar(Caption), MB_ICONINFORMATION or MB_OK)
        else
          MessageBox(Handle,
            PChar(IntToStr(num) + ' match(es) replaced.'),
            PChar(Caption), MB_ICONINFORMATION or MB_OK)
      end;
    finally
      Free;
    end;
end;

procedure TmainFrm.aRestoreSettingsExecute(Sender: TObject);
begin

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := 'Do you want to restore all application settings to their default values?';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Restore';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              RestoreDefaultSettings;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to restore all application settings to their default values?',
        PChar(Application.Title),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        RestoreDefaultSettings;
    end;

end;

procedure TmainFrm.aRevertExecute(Sender: TObject);
begin
  if not (FileExists(Editor.TextFile.FileName) and Editor.TextFile.FileModified) then
    Exit;

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(Editor.TextFile.FileName);
        Text := 'Do you want to revert this file to the last saved version?';
        FooterText := 'This operation cannot be undone.';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Revert';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              begin
                Screen.Cursor := crHourGlass;
                try
                  Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
                finally
                  Screen.Cursor := crDefault;
                end;
              end;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to revert this file to the last saved version?',
        PChar(ExtractFileName(Editor.TextFile.FileName)),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        begin
          Screen.Cursor := crHourGlass;
          try
            Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
          finally
            Screen.Cursor := crDefault;
          end;
        end;
    end;

  UpdateTabs;
  SetWindowCaption;
end;

procedure TmainFrm.aRevertUpdate(Sender: TObject);
begin
  aRevert.Enabled := Editor.TextFile.FileModified and FileExists(Editor.TextFile.FileName);
end;

procedure TmainFrm.aROT13Execute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_ROT13);
end;

procedure TmainFrm.aROT13Update(Sender: TObject);
begin
  aROT13.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_ROT13);
end;

procedure TmainFrm.aRowHighlightExecute(Sender: TObject);
begin
  Editor.LineHighlight := not Editor.LineHighlight;
end;

procedure TmainFrm.aRowHighlightUpdate(Sender: TObject);
begin
  aRowHighlight.Checked := Editor.LineHighlight;
end;

procedure TmainFrm.aRulerExecute(Sender: TObject);
begin
  aRuler.Checked := not aRuler.Checked;
  Editor.RulerVisible := aRuler.Checked;
end;

procedure TmainFrm.aRulerUpdate(Sender: TObject);
begin
  aRuler.Checked := Editor.RulerVisible;
end;

procedure TmainFrm.aSaveAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to high(FTextFiles) do
    if (not SaveFile(i)) and (i < high(FTextFiles)) and
      (MessageBox(Handle, 'Continue save all operation?', 'Save all', MB_ICONQUESTION or MB_YESNO) = ID_NO) then
      break;
end;

procedure TmainFrm.aSaveAsExecute(Sender: TObject);
begin
  SaveFileAs(ActiveFileIndex);
end;

procedure TmainFrm.aSaveAsUpdate(Sender: TObject);
begin
  aSaveAs.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SAVE);
end;

procedure TmainFrm.aSaveExecute(Sender: TObject);
begin
  SaveFile(ActiveFileIndex);
end;

procedure TmainFrm.aSaveUpdate(Sender: TObject);
begin
  aSave.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SAVE);
end;

procedure TmainFrm.aSelectAllExecute(Sender: TObject);
begin
  Editor.SelectAllNone;
end;

procedure TmainFrm.aSelectAllUpdate(Sender: TObject);
begin
  aSelectAll.Enabled := Editor.Focused and not Editor.TextFile.Empty;
  if Editor.TextFile.AllSelected and not Editor.TextFile.Empty then
    aSelectAll.Caption := 'Select nothing'
  else
    aSelectAll.Caption := 'Select all';
end;

procedure TmainFrm.aSelectionToNewBufferExecute(Sender: TObject);
begin
  NewBufferWithContents(Editor.SelText);
end;

procedure TmainFrm.aSelectionToNewBufferUpdate(Sender: TObject);
begin
  aSelectionToNewBuffer.Enabled := Editor.TextFile.HasSelection;
end;

procedure TmainFrm.aSelectLineExecute(Sender: TObject);
begin
  Editor.SelectLine;
end;

procedure TmainFrm.aSelectLineUpdate(Sender: TObject);
begin
  aSelectLine.Enabled := Editor.Focused and
    (Editor.TextFile.PhysicalLineWidths[Editor.CaretPos.Y] > 0);
end;

procedure TmainFrm.aSelectWordExecute(Sender: TObject);
begin
  Editor.SelectWord;
end;

procedure TmainFrm.aSelectWordUpdate(Sender: TObject);
begin
  aSelectWord.Enabled := Editor.Focused and (Editor.GetWord <> '');
end;

procedure TmainFrm.aSentenceCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_SENTENCE_CASE);
end;

procedure TmainFrm.aSentenceCaseUpdate(Sender: TObject);
begin
  aSentenceCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_SENTENCE_CASE);
end;

procedure TmainFrm.aSetBgColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.BackgroundColor;
  if SelectColor(c) then
    Editor.BackgroundColor := c;
end;

procedure TmainFrm.aSetBgColorUpdate(Sender: TObject);
begin
  aSetBgColor.Enabled := not Editor.UseSystemColors;
end;

procedure TmainFrm.aSetBracketHighlightColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.BracketHighlightColor;
  if SelectColor(c) then
    Editor.BracketHighlightColor := c;
end;

procedure TmainFrm.aSetFPAssocExecute(Sender: TObject);
begin
  ShowSettingsDialog(2);
end;

procedure TmainFrm.aSetRowHighlightColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.LineHighlightColor;
  if SelectColor(c) then
    Editor.LineHighlightColor := c;
end;

procedure TmainFrm.aSetRulerBackgroundColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.RulerColor;
  if SelectColor(c) then
    Editor.RulerColor := c;
end;

procedure TmainFrm.aSetRulerTextColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.RulerFont.Color;
  if SelectColor(c) then
    Editor.RulerFont.Color := c;
end;

procedure TmainFrm.aSetSearchHighlightColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.FindBackgroundColor;
  if SelectColor(c) then
    Editor.FindBackgroundColor := c;
end;

procedure TmainFrm.aSetSearchHighlightTextColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.FindForegroundColor;
  if SelectColor(c) then
    Editor.FindForegroundColor := c;
end;

procedure TmainFrm.aSetSelBgColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.SelBackgroundColor;
  if SelectColor(c) then
    Editor.SelBackgroundColor := c;
end;

procedure TmainFrm.aSetSelBgColorUpdate(Sender: TObject);
begin
  aSetSelBgColor.Enabled := not Editor.UseSystemColors;
end;

procedure TmainFrm.aSetSelFgColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.SelForegroundColor;
  if SelectColor(c) then
    Editor.SelForegroundColor := c;
end;

procedure TmainFrm.aSetSelFgColorUpdate(Sender: TObject);
begin
  aSetSelFgColor.Enabled := not Editor.UseSystemColors;
end;

procedure TmainFrm.aSetTabLengthExecute(Sender: TObject);
var
  v: integer;
begin
  v := Editor.TabLength;
  if TMultiInputBox.NumInputBox(Self, 'Tab length', 'Please enter the tab length:', v, 0, 1024) then
    Editor.TabLength := v;
end;

procedure TmainFrm.aSetTextColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.ForegroundColor;
  if SelectColor(c) then
    Editor.ForegroundColor := c;
end;

procedure TmainFrm.aSetTextColorUpdate(Sender: TObject);
begin
  aSetTextColor.Enabled := not Editor.UseSystemColors;
end;

procedure TmainFrm.aSettingsExecute(Sender: TObject);
begin
  ShowSettingsDialog;
end;

procedure TmainFrm.aShellExecuteFileExecute(Sender: TObject);
begin
  if FileExists(Editor.TextFile.FileName) then
    ShellExecute(Handle, nil, PChar(Editor.TextFile.FileName), nil, nil, SW_SHOWNORMAL);
end;

procedure TmainFrm.aShellExecuteFileUpdate(Sender: TObject);
begin
  aShellExecuteFile.Enabled := FileExists(Editor.TextFile.FileName);
end;

procedure TmainFrm.aShowAutoReplaceListExecute(Sender: TObject);
var
  i: integer;
begin
  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;

  with FTextFiles[high(FTextFiles)] do
  begin
    NewFile;
    InsertLine('Auto-replace codes', 'Heading 2', 0);
    BeginAddLine;
    for i := 0 to AutoReplaceItemCount - 1 do
      with AutoReplaceItems[i] do
        AddLine(Token + ': ' + ReplacedValue);
    EndAddLine;
    EditMode := emReadOnly;
    FileModified := false;
    FileName := 'Auto-replace codes';
    GotoSOF;
    with EditorState do
    begin
      Valid := true;
      MultiSize := true;
    end;
  end;

  UpdateTabs;
  Editor.LoadDefaultClasses;
  GotoFile(high(FTextFiles));
  Editor.MakeUndoRoot;
end;

function LineComparerStrLen(const A, B: string): integer;
begin
  result := Length(A) - Length(B);
end;

function LineComparerIntegers(const A, B: string): integer;
var
  Ai, Bi: integer;
begin
  result := 0;
  if TryStrToInt(A, Ai) and TryStrToInt(B, Bi) then
    result := Ai - Bi;
end;

function LineComparerReals(const A, B: string): integer;
var
  Ar, Br: extended;
begin
  result := 0;
  if TryStrToFloat(A, Ar) and TryStrToFloat(B, Br) then
    result := sign(Ar - Br);
end;

procedure TmainFrm.aSortLinesExecute(Sender: TObject);
begin
  with TsortFrm.Create(nil) do
    try
      cbComparer.ItemIndex := 0;
      rbSelection.Enabled := Editor.TextFile.HasSelection;
      if rbSelection.Enabled then
        rbSelection.Checked := true
      else
        rbEntireFile.Checked := true;
      if ShowModal = mrOk then
      begin
        case cbComparer.ItemIndex of
          0:
            Editor.LineComparer := AnsiCompareText;
          1:
            Editor.LineComparer := AnsiCompareStr;
          2:
            Editor.LineComparer := LineComparerStrLen;
          3:
            Editor.LineComparer := LineComparerIntegers;
          4:
            Editor.LineComparer := LineComparerReals;
        else
          Editor.LineComparer := nil;
        end;
        Editor.SortReverseOrder := cbReverse.Checked;
        Screen.Cursor := crHourGlass;
        try
          if rbSelection.Checked then
            Editor.SortSelection
          else
            Editor.Sort;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    finally
      Free;
    end;
end;

procedure TmainFrm.aSortLinesUpdate(Sender: TObject);
begin
  aSortLines.Enabled := Editor.LineCount > 1;
end;

procedure TmainFrm.aStatisticsExecute(Sender: TObject);
begin
  with TstatisticsFrm.Create(nil) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TmainFrm.aStatusBarExecute(Sender: TObject);
begin
  aStatusBar.Checked := not aStatusBar.Checked;
  StatusBar.Visible := aStatusBar.Checked;
end;

procedure TmainFrm.aStatusBarUpdate(Sender: TObject);
begin
  aStatusbar.Checked := StatusBar.Visible;
end;

procedure TmainFrm.aStatusMsgCopyExecute(Sender: TObject);
begin
  Clipboard.AsText := Statusbar.Panels[STATUS_MESSAGE].Text;
end;

const
  TipsOfTheDays: array[0..38] of string = (
    'To insert the Unicode character with codepoint U+ABCD, simply write ABCD and press Ctrl+U (like Alt+X in Microsoft Word).',
    'Press Ctrl+D to delete the current line.',
    'Press Shift+Ctrl+Arrow Up/Down to move the current line up or down in the document.',
    'Press Shift+Ctrl+A to select the current word.',
    'Press Ctrl+L to select the current line.',
    'Using the Paste As dialog box (Shift+Ctrl+V), you can easily paste a block of text as an HTML ordered or unordered list, for example.',
    'Text files can be dragged to an editor window from the Windows Explorer. You can drag a selection of several files; each file will then be opened in a new editor tab.',
    'Pressing Ctrl+C (Copy) when there is no selection will automatically copy the current word to clipboard. ("The current word" refers to the word in which the caret is positioned at the moment.) You get a visual indication of this.',
    'Hold down the Control key and use the scroll wheel to zoom in and out in the document.',
    'Hold down the Alt key and use the scroll wheel to move up and down in the document, as you do with the up and down arrow keys.',
    'Hold down the Shift key while scrolling using the mouse wheel to scroll smoothly, one pixel at a time.',
    'Hold down the Alt key and drag using the mouse to pan the document. When the Alt key is down, you can also change the scroll pos using the keyboard''s arrow keys.',
    'You can use the Pause key on the keyboard to toggle Read-Only mode on/off.',
    'Pressing Ctrl+A twice will undo the Select All operation, and select nothing.',
    'Using the Block Paste feature (Shift+Ctrl+Alt+V) you can paste a block of text as a block of text with its top-left corner at the caret, overwriting present characters, if any.',
    'Using the Truncate At feature (Edit/Truncate at...), you can truncate all lines in the document or in the current selection at a fixed character column or at the Nth occurrence of a given character on the line,'+' counting from the beginning or from the end of line.',
    'You can toggle the Caret beyond end of line (EOL) feature on and off by pressing Shift+Ctrl+Alt+C.',
    'When opening a text file in Rejbrand Text Editor, the application will try to determine the encoding of the file.'#13#10#13#10 + 'In most cases, the application will guess the correct encoding and simply open '+'the file. If the encoding cannot be positively determined, a dialog box will '+'ask you for the encoding to use; the most probable candidate is selected by default, and you can preview the text in the different encodings '+'before opening the file.'#13#10#13#10 + 'If the file is still opened using the wrong encoding, you can select a new encoding from the Encoding menu. If you choose a new encoding '+'immediately after the file has been opened, Rejbrand Text Editor will ask you if you want to reopen the file using the newly specified encoding.',
    'When you have inserted the hyphen-minus character (-) in the text, you may press F9 to display a dialog box with different kinds of hyphens, minus signs, and dashes: hyphens of different line-breaking types, '+'the minus sign, EN dash, EM dash, and so on. The character you select will replace the hyphen-minus.',
    'When you have inserted the asterisk character (*) in the text, you may press F9 to display a dialog box with different kinds of asterisks, bullets, and points, such as typographical bullets and mathematical '+'operators for multiplication and other binary operations. The character you select will replace the asterisk.',
    'When you have inserted a single or double quotation mark in the text, you may press F9 to display a dialog box with other kinds of (single or double) quotation marks, including typographical quotation marks in English, German, and Swedish.',
    'By pressing Shift+Ctrl+N, where N is a digit between 1 and 9, you set a bookmark at the caret location. Later, you can go to this location by pressing Ctrl+N.',
    'You can show or hide the ruler by pressing F4.',
    'Press F5 to insert the current date and time at the caret.',
    'Rejbrand Text Editor allows rapid insertion of many (X)HTML tags. See the Insert/(X)HTML menu for the options, and their associated shortcuts.',
    'The Unicode codepoint and description of the character at the caret (to the right of the caret), the currently selected character, or the newly typed character, '+'is shown in the status bar. You can double-click this status bar panel to copy its text to the clipboard.',
    'When writing text in English, make sure not to confuse "its" (possessive) with "it''s" (="it is", "it has").',
    'You can press Shift+Ctrl+O to revert a document to the last saved version of it (that is, the current buffer will be discarded and the document reloaded from the file).',
    'You can use File/Delete file to remove the current document''s file from the file system. The text will still be available in the buffer, but not associated with any file on the disk.',
    'You can press Ctrl+F9 to open the current file using the Windows shell. For instance, if you edit an HTML document saved to a file, pressing Ctrl+F9 is likely to open the (saved version of the) file in your default web browser.',
    'You can press Shift+Ctrl+F9 to open the folder (using Windows Explorer) containing the current file (if the current document is saved to a file).',
    'To search the document, press Ctrl+F (for "find") and enter the search phrase. The matches will be highlighted in the text, and you can navigate between them using F2 (previous match) and F3 (next match). '+'Press Esc to close the search bar and set focus to the editor again; you can continue to use F2 and F3 until you modify the text in the editor.',
    'To export the current document to an (X)HTML document, use File/Export to HTML or press Shift+Ctrl+Alt+X. The HTML file will contain all formatting of the text (line classes and interactive formatting/syntax highlighting).',
    'Pressing the middle mouse button (scroll-wheel button) on a tab will close the tab (as in all decent software).',
    'Most contemporary Windows text editors offer multi-step undo. But most of these share the established Windows multi-undo model, which has a major flaw: '+'if you undo a number of steps, to history version X of the file, say, and then modify the file, the undo history is truncated at X, so all history versions after X are lost (you cannot "redo" these).'#13#10#13#10 + 'This is dangerous, for instance, if you undo a large number of steps to recover a string you want to copy to the clipboard with the intention of redoing all steps immediately afterwards. '+'If you accidently make an edit to the file before or after you copy the string (say, by slipping and pressing C instead of Ctrl+C), all changes you made to the file after the restored version are permanently lost.'#13#10#13#10 +
      'In Rejbrand Text Editor, this "flaw" doesn''t exist: instead, when you make an edit and you are not at the end of the history stack, the old, restored, version is copied to the end of the stack, and no version in the history is deleted.',
    'You can press Shift+Ctrl+Z to show the revision history (undo history) of the file. You can also go back and forth in time using this dialog box.',
    'An asterisk (*) next to a file name indicates that the document has been modified; that is, the version in the editor buffer differs from the file on the disk (if any).',
    'Press F8 to quickly search the Unicode database for a character.',
    'You can start Rejbrand Text Editor by running (Windows key + R) "rteditor".');

procedure TmainFrm.TipOfTheDayVerificationClicked(Sender: TObject);
begin
  FAutoTip := not FAutoTip;
end;

procedure TmainFrm.aTipOfTheDayExecute(Sender: TObject);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'Rejbrand Text Editor';
        Title := 'Tip of the day';
        CommonButtons := [tcbClose];
        Text := TipsOfTheDays[Random(length(TipsOfTheDays))];
        with Buttons.Add do
        begin
          Caption := '&Another tip';
          ModalResult := mrRetry;
          Default := true;
        end;
        Flags := [tfUseHiconMain, tfAllowDialogCancellation];
        CustomMainIcon := Application.Icon;
        ExpandButtonCaption := 'Options';
        VerificationText := '&Show automatically on startup.';
        OnVerificationClicked := TipOfTheDayVerificationClicked;
        if FAutoTip then
          Flags := Flags + [tfVerificationFlagChecked];
        if ExecuteModally and (ModalResult = mrRetry) then aTipOfTheDay.Execute;
      finally
        Free;
      end
  else
    // Windows XP Compatibility Code
    MessageBox(Handle, PChar(TipsOfTheDays[Random(length(TipsOfTheDays))]), PChar('Rejbrand Text Editor'), MB_ICONINFORMATION);
end;

procedure TmainFrm.aToggleFocusExecute(Sender: TObject);
begin
  if Editor.Focused and TabList.Visible and TabList.CanFocus then
    TabList.SetFocus
  else if Editor.CanFocus then
    Editor.SetFocus;
end;

procedure TmainFrm.aTrimRightExecute(Sender: TObject);
begin
  Editor.TrimRight;
end;

procedure TmainFrm.aTruncateAtExecute(Sender: TObject);
begin
  with TtruncateFrm.Create(nil) do
    try
      if Editor.TextFile.HasSelection then
        rbSelection.Checked := true
      else
        rbEntireFile.Checked := true;

      if ShowModal = mrOk then
      begin

        if rbSelection.Checked then
        begin

          if rbColumn.Checked then
            Editor.TruncateAtInSelection(StrToInt(eColumn.Text), #0, false, cbReverse.Checked)
          else if rbSearch.Checked then
            Editor.TruncateAtInSelection(IfThen(cbDirection.ItemIndex = 1, -1, 1) * (cbOrdinal.ItemIndex + 1), eChr.Text[1], cbOffset.ItemIndex <> 0, cbReverse.Checked);

        end
        else if rbEntireFile.Checked then
        begin

          if rbColumn.Checked then
            Editor.TruncateAt(StrToInt(eColumn.Text), #0, false, cbReverse.Checked)
          else if rbSearch.Checked then
            Editor.TruncateAt(IfThen(cbDirection.ItemIndex = 1, -1, 1) * (cbOrdinal.ItemIndex + 1), eChr.Text[1], cbOffset.ItemIndex <> 0, cbReverse.Checked);

        end

      end;
    finally
      Free;
    end;
end;

procedure TmainFrm.aRemoveAllIndentExecute(Sender: TObject);
begin
  Editor.RemoveAllIndent;
end;

procedure TmainFrm.aUndoExecute(Sender: TObject);
begin
  Editor.Undo;
end;

procedure TmainFrm.aUndoUpdate(Sender: TObject);
begin
  aUndo.Enabled := Editor.Focused and Editor.CanUndo;
end;

procedure TmainFrm.aUpperCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_UPPER_CASE);
end;

procedure TmainFrm.aUpperCaseUpdate(Sender: TObject);
begin
  aUpperCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_UPPER_CASE);
end;

procedure TmainFrm.aUseSystemDefaultColorsExecute(Sender: TObject);
begin
  Editor.UseSystemColors := not Editor.UseSystemColors;
end;

procedure TmainFrm.aUseSystemDefaultColorsUpdate(Sender: TObject);
begin
  aUseSystemDefaultColors.Checked := Editor.UseSystemColors;
end;

procedure TmainFrm.aVigenereDecryptExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_VIGENERE, 1)
end;

procedure TmainFrm.aVigenereDecryptUpdate(Sender: TObject);
begin
  aVigenereDecrypt.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_VIGENERE);
end;

procedure TmainFrm.aVigenereEncryptExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_VIGENERE)
end;

procedure TmainFrm.aVigenereEncryptUpdate(Sender: TObject);
begin
  aVigenereEncrypt.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_VIGENERE);
end;

procedure TmainFrm.cbFindMatchCaseClick(Sender: TObject);
begin
  DoInstantSearch;
end;

procedure TmainFrm.DoInstantSearch;
var
  FQ: TFindQuery;
  n: integer;
begin
  FQ.SearchString := eFind.Text;
  FQ.MatchCase := cbFindMatchCase.Checked;
  FQ.MatchWord := cbFindWholeWords.Checked;
  FQ.Linebreak := cbFindNewline.Checked;
  FQ.UCBlock := 0;
  n := Editor.Find(FQ);
  stNumMatches.Visible := Length(eFind.Text) > 0;
  if stNumMatches.Visible then
    stNumMatches.Caption := Format('%d match(es)', [n]);
end;

procedure TmainFrm.EditorFindDataClear(Sender: TObject);
begin
  stNumMatches.Caption := '';
  stNumMatches.Hide;
end;

procedure TmainFrm.EditorKeyPress(Sender: TObject; var Key: Char);
begin
  FKeyPressed := ord(Key) > $1F;
  StatusBarCharacterInfo(Key);
  CharacterInfo(Key);
end;

procedure TmainFrm.EditorModified(Sender: TObject);
begin
  UpdateTabs;
  SetWindowCaption;
end;

procedure TmainFrm.UpdateNotificationsWindow;
var
  i: integer;
begin
  if Assigned(notificationsFrm) and notificationsFrm.Visible then
    with notificationsFrm.lbNotifications do
    begin
      Items.BeginUpdate;
      Items.Clear;
      for i := 0 to Editor.NotificationCount - 1 do
        Items.Add(Editor.NotificationStr[Editor.Notifications[i]]);
      Items.EndUpdate;
    end;
end;

procedure TmainFrm.EditorNotification(Sender: TObject; MsgID: Cardinal;
  AClear: Boolean);
begin
  UpdateNotificationsWindow;
end;

procedure TmainFrm.EditorOverwriteChange(Sender: TObject);
begin
  StatusBar.Panels[STATUS_OVERWRITE].Text := IfThen(Editor.Overwrite, 'OVER', 'INS');
end;

procedure TmainFrm.EditorPrintBegin(Sender: TObject; NumSteps: Integer);
begin
  TabList.Enabled := false;
  EnableWindow(TabList.Handle, false);
  FDoAbortPrinting := false;
  ActionList.State := asSuspended;
  printingFrm.stDocName.Caption := ExtractFileName(Editor.TextFile.FileName);
  printingFrm.stPrinterName.Caption := Printer.Printers[Printer.PrinterIndex];
  printingFrm.stPrintProgress.Caption := '0 %';
  printingFrm.Show;
  if printingFrm.CanFocus then
    printingFrm.SetFocus;
end;

procedure TmainFrm.EditorPrintEnd(Sender: TObject);
begin
  printingFrm.Hide;
  TabList.Enabled := true;
  EnableWindow(TabList.Handle, true);
  ActionList.State := asNormal;
end;

function TmainFrm.EditorPrintProgress(Sender: TObject; CurStep,
  NumSteps: Integer): Boolean;
begin
  if not printingFrm.Visible then
    printingFrm.Show;

  printingFrm.stPrintProgress.Caption := FormatFloat('0.0', 100*CurStep/NumSteps) + ' %';
  result := not FDoAbortPrinting;
end;

procedure TmainFrm.EditorSelChange(Sender: TObject);
var
  c: char;
begin
  if Editor.TextFile.HasSelection then
    if Editor.CaretPos.Y = Editor.SelEndPos.Y then
      StatusBar.Panels[STATUS_FILE_POSITION].Text :=
        Format('Line: %d  Cols: %d–%d  Len: %d',
          [Editor.CaretPos.Y + 1,
           min(Editor.CaretPos.X, Editor.SelEndPos.X) + 1,
           max(Editor.CaretPos.X, Editor.SelEndPos.X) + 1,
           Editor.SelLength])
    else
      StatusBar.Panels[STATUS_FILE_POSITION].Text :=
        Format('Lines: %d–%d  Len: %d',
          [min(Editor.CaretPos.Y, Editor.SelEndPos.Y) + 1,
           max(Editor.CaretPos.Y, Editor.SelEndPos.Y) + 1,
           Editor.SelLength])
  else
    StatusBar.Panels[STATUS_FILE_POSITION].Text :=
      Format('Line: %d  Col: %d  Chr: %d',
        [Editor.CaretPos.Y + 1, Editor.CaretPos.X + 1, Editor.SelStart + 1]);

  if not FKeyPressed then
  begin
    c := Editor.GetCharAtCaret;
    StatusBarCharacterInfo(c);
    CharacterInfo(c);
  end;

  FKeyPressed := false;
end;

procedure TmainFrm.CharacterInfo(const AChar: char);
begin
  if Assigned(chrFrm) and chrFrm.Visible then
  begin
    chrFrm.eChr.Text := AChar;
    chrFrm.eChrName.Text := UCD.GetChrName(AChar);
    chrFrm.eChrBlock.Text := UCD.GetChrBlock(AChar);
    chrFrm.eCode.Text := UCD.GetChrCodepointStr(AChar);
  end;
end;

function TmainFrm.HasImportantNotification: boolean;
begin
  result := Editor.HasNotificationMessage(TTextEditor.EN_DRAG_MOVE) or
    Editor.HasNotificationMessage(TTextEditor.EN_DRAG_COPY) or
    Editor.HasNotificationMessage(TTextEditor.EN_SCRIPT) or
    Editor.HasNotificationMessage(TTextEditor.EN_MULTICARET);
end;

procedure TmainFrm.StatusBarCharacterInfo(c: Char);
begin
  if not HasImportantNotification then
    StatusBar.Panels[STATUS_MESSAGE].Text := UCD.GetChrCodepointStr(c) + ': ' + UCD.GetChrName(c);
end;

procedure TmainFrm.StatusBarContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  Handled := true;

  if (MousePos.X = -1) and (MousePos.Y = -1) then
    Exit;


  if InRange(MousePos.X,
    0,
    StatusBar.Panels[STATUS_FILE_POSITION].Width) then
  begin
    with StatusBar.ClientToScreen(MousePos) do
      StatusPosPopup.Popup(X, Y);
  end
  else if InRange(MousePos.X,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width + StatusBar.Panels[STATUS_MESSAGE].Width) then
  begin
    with StatusBar.ClientToScreen(MousePos) do
      StatusMessagePopup.Popup(X, Y);
  end;

end;

procedure TmainFrm.StatusBarDblClick(Sender: TObject);
var
  p: TPoint;
begin
  if not GetCursorPos(p) then Exit;
  p := StatusBar.ScreenToClient(p);

  if InRange(p.X,
    0,
    StatusBar.Panels[STATUS_FILE_POSITION].Width) then
  begin
    aGoTo.Execute;
  end
  else if InRange(p.X,
    StatusBar.Panels[STATUS_FILE_POSITION].Width,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width) then
  begin
    Editor.Overwrite := not Editor.Overwrite;
  end
  else if InRange(p.X,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width + StatusBar.Panels[STATUS_MESSAGE].Width) then
  begin
    aStatusMsgCopy.Execute;
  end;

end;

procedure TmainFrm.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  if Panel = StatusBar.Panels[STATUS_ZOOM_CONTROL] then
    ZoomControl.BoundsRect := Classes.Rect(Rect.Left, Rect.Top,
      Rect.Right - GetSizeGripSize, Rect.Bottom);
end;

function TmainFrm.GetSettingsFileName: string;
begin
  result := GetDriveAccess + 'settings.ini';
end;

procedure TmainFrm.NewBufferWithContents(const S: string);
begin
  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;
  FTextFiles[high(FTextFiles)].NewFile;
  FTextFiles[high(FTextFiles)].PlainText := S;
  FTextFiles[high(FTextFiles)].GotoSOF;
  FTextFiles[high(FTextFiles)].AddUndoRecord(SUndoNewFile, UID_UNKNOWN);
  FTextFiles[high(FTextFiles)].FileModified := false;
  UpdateTabs;
  GotoFile(high(FTextFiles));
end;

procedure TmainFrm.OpenMnuURL(Sender: TObject);
begin
  if Sender is TMenuItem then
    ShellExecute(Handle, 'open', PChar(TMenuItem(Sender).Hint), nil, nil, SW_SHOWNORMAL)
end;

procedure TmainFrm.ShowSettingsDialog(DefaultTab: Integer);
begin
  with TsettingsFrm.Create(nil) do
    try
      case Editor.ScrollBehaviour of
        sbDefault:
          rbScrollDef.Checked := true;
        sbLine:
          rbScrollLine.Checked := true;
        sbPixel:
          rbScrollPixel.Checked := true;
      end;
      cbDefEffect.ItemIndex := ord(Editor.BitmapEffect);
      cbDisabledEffect.ItemIndex := ord(Editor.DisabledEffect);
      eXML.Text := FSynHighlightAssocs[SYN_XML];
      eHTML.Text := FSynHighlightAssocs[SYN_HTML];
      eCSS.Text := FSynHighlightAssocs[SYN_CSS];
      eMW.Text := FSynHighlightAssocs[SYN_MW];
      ePascal.Text := FSynHighlightAssocs[SYN_PAS];
      eAlgoSim.Text := FSynHighlightAssocs[SYN_AS];
      eINI.Text := FSynHighlightAssocs[SYN_INI];
      lbReadOnlyAssocs.Items.Delimiter := ',';
      lbReadOnlyAssocs.Items.DelimitedText := FReadOnlyAssocs;
      lbTrimAssocs.Items.Delimiter := ',';
      lbTrimAssocs.Items.DelimitedText := FTrimAssocs;
      pcSettings.TabIndex := DefaultTab;
      if ShowModal = mrOk then
      begin
        if rbScrollDef.Checked then
          Editor.ScrollBehaviour := sbDefault
        else if rbScrollLine.Checked then
          Editor.ScrollBehaviour := sbLine
        else if rbScrollPixel.Checked then
          Editor.ScrollBehaviour := sbPixel;
        Editor.BitmapEffect := TBitmapEffect(cbDefEffect.ItemIndex);
        Editor.DisabledEffect := TBitmapEffect(cbDisabledEffect.ItemIndex);
        FSynHighlightAssocs[SYN_XML] := eXML.Text;
        FSynHighlightAssocs[SYN_HTML] := eHTML.Text;
        FSynHighlightAssocs[SYN_CSS] := eCSS.Text;
        FSynHighlightAssocs[SYN_MW] := eMW.Text;
        FSynHighlightAssocs[SYN_PAS] := ePascal.Text;
        FSynHighlightAssocs[SYN_AS] := eAlgoSim.Text;
        FSynHighlightAssocs[SYN_INI] := eINI.Text;
        FReadOnlyAssocs := lbReadOnlyAssocs.Items.DelimitedText;
        FTrimAssocs := lbTrimAssocs.Items.DelimitedText;
        SaveSettingsToFile;
      end;
    finally
      Free;
    end;
end;

function TmainFrm.GetSizeGripSize: integer;
begin
  if (WindowState = wsNormal) and StatusBar.SizeGrip then
    result := 16
  else
    result := 0;
end;

procedure TmainFrm.EditorSimpleNotification(Sender: TObject; MsgID: Cardinal;
  const AStr: string);
begin
  StatusBar.Panels[STATUS_MESSAGE].Text := AStr;
end;

procedure TmainFrm.EditorZoomChange(Sender: TObject);
begin
  ZoomControl.UpdateZoomLevelSilently(Editor.Zoom);
end;

procedure TmainFrm.FormActivate(Sender: TObject);
begin
  if FAutoTip and FFirstActivate then
    aTipOfTheDay.Execute;
  FFirstActivate := false;
end;

procedure TmainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveSettingsToFile;
end;

procedure TmainFrm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: Integer;
begin
  CanClose := true;
  for i := 0 to high(FTextFiles) do
    if FTextFiles[i].FileModified then
      if not QueryFileSave(i) then
      begin
        CanClose := false;
        break;
      end;
end;

procedure TmainFrm.FormCreate(Sender: TObject);
var
  i: Integer;
begin

//  ReportMemoryLeaksOnShutdown := true;

  CreateMutex(nil, false, PChar(REJBRAND_MUTEX_RTE_RTEDITOR));

  // Tip of the Day, for example
  Randomize;

  // Fields
  FDisabledByModality := false;
  FFirstActivate := true;
  FKeyPressed := false;
  FFirstTimeChrDlg := true;

  // Create new file
  Editor.NewFile;

  // Make sure the client owns the files
  Editor.TextFileOwner := tfoApplication;

  // Initial text file created by editor control
  SetLength(FTextFiles, 1);
  FTextFiles[0] := Editor.TextFile;
  UpdateTabs;
  SetWindowCaption;

  // Load settings
  LoadSettingsFromFile;

  // Process command-line arguments
  try
    for i := 1 to ParamCount do
      LoadFile(ParamStr(i));
  finally
    if Length(FTextFiles) > 1 then
      CloseFile(0);
  end;

  // Drop target
  DragAcceptFiles(Handle, true);

end;

procedure TmainFrm.FormShow(Sender: TObject);
begin
  ZoomControl.Parent := StatusBar;
end;

procedure TmainFrm.UpdateTabs;
var
  i: Integer;
begin
  TabList.Items.BeginUpdate;
  TabList.Items.Clear;
  for i := 0 to high(FTextFiles) do
  begin
    TabList.Items.Add(ExtractFileName(FTextFiles[i].FileName) + IfThen(FTextFiles[i].FileModified, ' *'));
    if Editor.TextFile = FTextFiles[i] then
      TabList.ActiveTab := i;
  end;
  TabList.Items.EndUpdate;
  TabList.Visible := TabList.Items.Count > 1;
end;

procedure TmainFrm.WMDropFiles(var Message: TWMDropFiles);
var
  count: integer;
  i: Integer;
  FileName: array[0..MAX_PATH] of Char;
begin
  inherited;

  try
    count := DragQueryFile(Message.Drop, $FFFFFFFF, nil, 0);
    for i := 0 to Count - 1 do
      if DragQueryFile(Message.Drop, i, FileName, MAX_PATH) > 0 then
        LoadFile(FileName);
  finally
    DragFinish(Message.Drop);
  end;

  Message.Result := 0;
end;

procedure TmainFrm.WMExitMenuLoop(var Message: TWMExitMenuLoop);
begin
  inherited;
  Editor.EditorCommand(EDITOR_COMMAND_UPDATE_SCROLL_MODE);
end;

procedure TmainFrm.ZoomControlChange(Sender: TObject);
begin
  Editor.Zoom := ZoomControl.ZoomLevel;
end;

function TmainFrm.GetLastNotification: string;
begin
  if Editor.NotificationCount > 0 then
    result := Editor.NotificationStr[Editor.Notifications[Editor.NotificationCount - 1]]
  else
    result := '';
end;

procedure TmainFrm.GotoFile(FileIndex: integer);
begin
  Editor.TextFile := FTextFiles[FileIndex];
  TabList.ActiveTab := FileIndex;
  SetWindowCaption;
  stNumMatches.Caption := '';
  stNumMatches.Hide;
  pnSearch.Hide;
  mnuEncoding.Enabled := not Editor.TextFile.StrictReadOnly;
  EditorSelChange(Self);
  StatusBar.Panels[STATUS_MESSAGE].Text := GetLastNotification;
  UpdateNotificationsWindow;
end;

procedure TmainFrm.SetWindowCaption;
begin
  Caption := ExtractFileName(Editor.TextFile.FileName) + IfThen(Editor.TextFile.FileModified, ' *');
end;

procedure TmainFrm.TabListChange(Sender: TObject);
begin
  GotoFile(TabList.ActiveTab);
end;

procedure TmainFrm.TabListMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbMiddle then
    CloseFile(ActiveFileIndex);
end;

function TmainFrm.SaveFile(FileIndex: integer): boolean;
var
  TF: TTextFile;
begin
  TF := FTextFiles[FileIndex];
  if FileExists(TF.FileName) then
  begin
    try
      TF.SaveToFile(TF.FileName, GetTrimRight(TF.FileName));
      result := true;
    except
      on E: Exception do
      begin
        ShowErrorMessage(Format('An error occurred trying to save file "%s".'#13#10 + E.Message, [ExtractFileName(TF.FileName)]));
        result := false;
      end;
    end;
    UpdateTabs;
    SetWindowCaption;
  end
  else
    result := SaveFileAs(FileIndex);
end;

function TmainFrm.SaveFileAs(FileIndex: integer): boolean;
var
  TF: TTextFile;
  EFD, EFN: string;
begin
  TF := FTextFiles[FileIndex];
  result := false;
  if ActiveFileIndex <> FileIndex then
    GotoFile(FileIndex);
  with TSaveDialog.Create(nil) do
    try
      Options := [ofOverwritePrompt, ofPathMustExist];
      EFD := ExtractFileDir(TF.FileName);
      if DirectoryExists(EFD) then
        InitialDir := EFD;
      EFN := ExtractFileName(TF.FileName);
      if (EFN = '') or StartsText('New file', EFN) then
        FileName := GetInitialFileName(TF)
      else
        FileName := EFN;
      if Execute then
      begin
        try
          TF.SaveToFile(FileName, GetTrimRight(TF.FileName));
          result := true;
        except
          on E: Exception do
          begin
            ShowErrorMessage(Format('An error occurred trying to save file "%s".'#13#10 + E.Message, [ExtractFileName(TF.FileName)]));
            result := false;
          end;
        end;
        UpdateTabs;
        SetWindowCaption;
        ApplyAssocFormattingProcessor;
      end;
    finally
      Free;
    end;
end;

function TmainFrm.GetInitialFileName(const ATextFile: TTextFile): string;
var
  i, j: Integer;
begin
  result := '';
  if not Assigned(ATextFile) then Exit;
  if ATextFile.LineCount = 0 then Exit;
  result := Copy(ATextFile.Lines[0], 1, 64);
  for i := Length(result) downto 1 do
    if CharInSet(result[i], ['<', '>', ':', '"', '/', '\', '|', '?', '*']) or (result[i] < ' ') then
      Delete(result, i, 1);
  result := Trim(result);
  j := 0;
  for i := Length(result) downto 1 do
    if not CharInSet(result[i], [' ', '.']) then
    begin
      j := i;
      break;
    end;
  SetLength(result, j);
  if Length(result) > 0 then
    result := result + '.txt';
end;

function TmainFrm.GetTrimRight(const AFileName: TFileName): boolean;
begin
  result := ItemInList(ExtractFileExt(AFileName), FTrimAssocs);
end;

function TmainFrm.QueryFileSave(FileIndex: integer): boolean;
var
  TF: TTextFile;
begin
  result := false;
  TF := FTextFiles[FileIndex];
  if not TF.FileModified then Exit(true);
  GotoFile(FileIndex);
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(TF.FileName);
        Text := 'Do you want to save the changes made to this text file?';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Save';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Don''t save';
          ModalResult := mrNo;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              result := SaveFile(FileIndex);
            mrNo:
              result := true;
            mrCancel:
              result := false;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        PChar(Format('Do you want to save the changes made to "%s"?',
          [ExtractFileName(TF.FileName)])), PChar(Application.Title),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        result := SaveFile(FileIndex);
      ID_NO:
        result := true;
      ID_CANCEL:
        result := false;
    end;
end;

function TmainFrm.CloseFile(FileIndex: integer; CloseApp: boolean = true): boolean;
var
  TF: TTextFile;
  i: Integer;
begin

  TF := FTextFiles[FileIndex];

  result := (not TF.FileModified) or QueryFileSave(FileIndex);

  if not result then Exit;


  if (Length(FTextFiles) = 1) and not CloseApp then
  begin
    // Simply replace current file (discard any changes) with a new one
    aNew.Execute;
    FTextFiles[0] := FTextFiles[1];
    SetLength(FTextFiles, 1);
    TF.Free;
    UpdateTabs;
    if Visible and Editor.CanFocus then
      Editor.SetFocus;
    Exit;
  end;


  if FileIndex = ActiveFileIndex then
    if FileIndex < high(FTextFiles) then
      GotoFile(FileIndex + 1)
    else if FileIndex > 0 then
      GotoFile(FileIndex - 1)
    else
      Editor.TextFile := nil;

  for i := FileIndex to high(FTextFiles) - 1 do
    FTextFiles[i] := FTextFiles[i + 1];

  SetLength(FTextFiles, Length(FTextFiles) - 1);

  TF.Free;

  if Length(FTextFiles) > 0 then
    UpdateTabs
  else
    Close;

  if not TabList.Visible then
    if Visible and Editor.CanFocus then
      Editor.SetFocus;

end;

procedure TmainFrm.eFindChange(Sender: TObject);
begin
  DoInstantSearch;
end;

procedure TmainFrm.eFindKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = chr(VK_RETURN) then
  begin
    DoInstantSearch;
    if (GetKeyState(VK_SHIFT) shr 16) <> 0 then
      aFindPrev.Execute
    else
      aFindNext.Execute;
    Key := #0;
  end;
  if Key = chr(VK_ESCAPE) then
  begin
    pnSearch.Hide;
    Key := #0;
    if Editor.CanFocus then
      Editor.SetFocus;
  end;
end;

procedure TmainFrm.aCopyExecute(Sender: TObject);
var
  CP: TPoint;
begin
  if Editor.TextFile.HasSelection then
    Editor.CopyToClipboard
  else if Length(Editor.GetWord) > 0 then
  begin
    CP := Editor.CaretPos;
    Editor.SelectWord;
    Editor.CopyToClipboard;
    Sleep(250);
    Editor.CaretPos := CP;
  end;
end;

procedure TmainFrm.aCopyUpdate(Sender: TObject);
begin
  aCopy.Enabled := Editor.Focused and (Editor.TextFile.HasSelection or (Length(Editor.GetWord) > 0));
end;

function TmainFrm.ActiveFileIndex: integer;
begin
  result := TabList.ActiveTab;
end;

procedure TmainFrm.ShowErrorMessage(const Str: string);
begin
  MessageBox(Handle, PChar(Str), PChar(Application.Title), MB_ICONERROR or MB_OK);
end;

procedure TmainFrm.StatusBarResize(Sender: TObject);
begin
  StatusBar.Panels[STATUS_MESSAGE].Width := StatusBar.Width -
    StatusBar.Panels[STATUS_FILE_POSITION].Width -
    StatusBar.Panels[STATUS_OVERWRITE].Width -
    StatusBar.Panels[STATUS_ZOOM_CONTROL].Width;
end;

function TmainFrm.SelectColor(var AColor: TColor): boolean;
begin
  with ColorDialog.TColorDialog.Create(nil) do
    try
      Color := AColor;
      result := Execute;
      if result then
        AColor := Color;
    finally
      Free;
    end;
end;

const
  SEV = 'Editor appearance';
  SEB = 'Editor behaviour';
  APPS = 'Application settings';
  ASS = 'Associations';

procedure TmainFrm.SaveSettingsToFile;
begin
  with TIniFile.Create(GetSettingsFileName) do
    try
      WriteInteger(SEV, 'Bitmap effect', ord(Editor.BitmapEffect));
      WriteInteger(SEV, 'Disabled effect', ord(Editor.DisabledEffect));

      WriteString(SEV, 'Font', Editor.Font.Name);
      WriteInteger(SEV, 'Font size', Editor.Font.Size);
      WriteInteger(SEV, 'Background color', Editor.BackgroundColor);
      WriteInteger(SEV, 'Foreground color', Editor.ForegroundColor);
      WriteInteger(SEV, 'Selection background color', Editor.SelBackgroundColor);
      WriteInteger(SEV, 'Selection foreground color', Editor.SelForegroundColor);
      WriteInteger(SEV, 'Find highlight background color', Editor.FindBackgroundColor);
      WriteInteger(SEV, 'Find highlight foreground color', Editor.FindForegroundColor);
      WriteInteger(SEV, 'Row highlight color', Editor.LineHighlightColor);
      WriteInteger(SEV, 'Bracket highlight color', Editor.BracketHighlightColor);
      WriteInteger(SEV, 'Ruler color', Editor.RulerColor);
//      WriteInteger(SEV, 'Ruler width', Editor.RulerWidth);
      WriteBool(SEV, 'Ruler visible', Editor.RulerVisible);
      WriteString(SEV, 'Ruler font', Editor.RulerFont.Name);
      WriteInteger(SEV, 'Ruler font size', Editor.RulerFont.Size);
      WriteInteger(SEV, 'Ruler font color', Editor.RulerFont.Color);
//      WriteInteger(SEV, 'Margin left', Editor.MarginLeft);
//      WriteInteger(SEV, 'Margin top', Editor.MarginTop);
//      WriteInteger(SEV, 'Margin right', Editor.MarginRight);
//      WriteInteger(SEV, 'Margin bottom', Editor.MarginBottom);
      WriteBool(SEV, 'Row highlight', Editor.LineHighlight);
      WriteBool(SEV, 'Use system colors', Editor.UseSystemColors);
      WriteBool(SEV, 'Show hidden characters', Editor.ShowHiddenCharacters);

      WriteBool(SEB, 'Caret beyond EOL', Editor.CaretAfterEOL);
      WriteBool(SEB, 'Auto indent', Editor.AutoIndent);
      WriteBool(SEB, 'Auto replace', Editor.AutoReplace);
      WriteBool(SEB, 'Bracket highlight', Editor.MatchBrackets);
      WriteBool(SEB, 'Multi char select', Editor.MultiCharSelect);
      WriteInteger(SEB, 'Tab length', Editor.TabLength);
      WriteInteger(SEB, 'Scroll behaviour', ord(Editor.ScrollBehaviour));

      WriteBool(APPS, 'Status bar', StatusBar.Visible);
      WriteBool(APPS, 'Tip of the day', FAutoTip);

      WriteString(ASS, 'XML', FSynHighlightAssocs[SYN_XML]);
      WriteString(ASS, 'HTML', FSynHighlightAssocs[SYN_HTML]);
      WriteString(ASS, 'CSS', FSynHighlightAssocs[SYN_CSS]);
      WriteString(ASS, 'MediaWiki', FSynHighlightAssocs[SYN_MW]);
      WriteString(ASS, 'Pascal', FSynHighlightAssocs[SYN_PAS]);
      WriteString(ASS, 'AlgoSim', FSynHighlightAssocs[SYN_AS]);
      WriteString(ASS, 'INI', FSynHighlightAssocs[SYN_INI]);

      WriteString(ASS, 'Read only', FReadOnlyAssocs);
      WriteString(ASS, 'Trim', FTrimAssocs);
    finally
      Free;
    end;
end;

procedure TmainFrm.LoadSettingsFromFile;
begin
  with TIniFile.Create(GetSettingsFileName) do
    try
      Editor.BitmapEffect := TBitmapEffect(ReadInteger(SEV, 'Bitmap effect', 0));
      Editor.DisabledEffect := TBitmapEffect(ReadInteger(SEV, 'Disabled effect', 1));

      Editor.Font.Name := ReadString(SEV, 'Font', 'DejaVu Sans Mono');
      Editor.Font.Size := ReadInteger(SEV, 'Font size', 10);
      Editor.BackgroundColor := ReadInteger(SEV, 'Background color', clWhite);
      Editor.ForegroundColor := ReadInteger(SEV, 'Foreground color', clBlack);
      Editor.SelBackgroundColor := ReadInteger(SEV, 'Selection background color', clBlack);
      Editor.SelForegroundColor := ReadInteger(SEV, 'Selection foreground color', clWhite);
      Editor.FindBackgroundColor := ReadInteger(SEV, 'Find highlight background color', clYellow);
      Editor.FindForegroundColor := ReadInteger(SEV, 'Find highlight foreground color', clBlack);
      Editor.LineHighlightColor := ReadInteger(SEV, 'Row highlight color', TTextEditor.DEFAULT_LINE_HIGHLIGHT_COLOR);
      Editor.BracketHighlightColor := ReadInteger(SEV, 'Bracket highlight color', TTextEditor.DEFAULT_BRACKET_HIGHLIGHT_COLOR);
      Editor.RulerColor := ReadInteger(SEV, 'Ruler color', clDefault);
//      Editor.RulerWidth := ReadInteger(SEV, 'Ruler width', TTextEditor.DEFAULT_RULER_WIDTH);
      Editor.RulerVisible := ReadBool(SEV, 'Ruler visible', true);
      Editor.RulerFont.Name := ReadString(SEV, 'Ruler font', 'Segoe UI');
      Editor.RulerFont.Size := ReadInteger(SEV, 'Ruler font size', 8);
      Editor.RulerFont.Color := ReadInteger(SEV, 'Ruler font color', clWindowText);
//      Editor.MarginLeft := ReadInteger(SEV, 'Margin left', TTextEditor.DEFAULT_MARGIN_LEFT);
//      Editor.MarginTop := ReadInteger(SEV, 'Margin top', TTextEditor.DEFAULT_MARGIN_TOP);
//      Editor.MarginRight := ReadInteger(SEV, 'Margin right', TTextEditor.DEFAULT_MARGIN_RIGHT);
//      Editor.MarginBottom := ReadInteger(SEV, 'Margin bottom', TTextEditor.DEFAULT_MARGIN_BOTTOM);
      Editor.LineHighlight := ReadBool(SEV, 'Row highlight', true);
      Editor.UseSystemColors := ReadBool(SEV, 'Use system colors', true);
      Editor.ShowHiddenCharacters := ReadBool(SEV, 'Show hidden characters', false);

      Editor.CaretAfterEOL := ReadBool(SEB, 'Caret beyond EOL', true);
      Editor.AutoIndent := ReadBool(SEB, 'Auto indent', true);
      Editor.AutoReplace := ReadBool(SEB, 'Auto replace', true);
      Editor.MatchBrackets := ReadBool(SEB, 'Bracket highlight', true);
      Editor.MultiCharSelect := ReadBool(SEB, 'Multi char select', true);
      Editor.TabLength := ReadInteger(SEB, 'Tab length', 2);
      Editor.ScrollBehaviour := TScrollBehaviour(ReadInteger(SEB, 'Scroll behaviour', ord(sbDefault)));
      if ReadBool(SEB, 'AlgoSim AutoToggle Behaviour', false) then
        Editor.EditorCommand(EDITOR_COMMAND_SET_AS_HYPHEN_ASTERISK_TOGGLE, 1);

      StatusBar.Visible := ReadBool(APPS, 'Status bar', true);
      FAutoTip := ReadBool(APPS, 'Tip of the day', false);

      FSynHighlightAssocs[SYN_XML] := ReadString(ASS, 'XML', DEFAULT_ASSOC_XML);
      FSynHighlightAssocs[SYN_HTML] := ReadString(ASS, 'HTML', DEFAULT_ASSOC_HTML);
      FSynHighlightAssocs[SYN_CSS] := ReadString(ASS, 'CSS', DEFAULT_ASSOC_CSS);
      FSynHighlightAssocs[SYN_MW] := ReadString(ASS, 'MediaWiki', DEFAULT_ASSOC_MW);
      FSynHighlightAssocs[SYN_PAS] := ReadString(ASS, 'Pascal', DEFAULT_ASSOC_PAS);
      FSynHighlightAssocs[SYN_AS] := ReadString(ASS, 'AlgoSim', DEFAULT_ASSOC_AS);
      FSynHighlightAssocs[SYN_INI] := ReadString(ASS, 'INI', DEFAULT_ASSOC_INI);

      FReadOnlyAssocs := ReadString(ASS, 'Read only', '');
      FTrimAssocs := ReadString(ASS, 'Trim', '');
    finally
      Free;
    end;
end;

procedure TmainFrm.LoadSingleInstanceRTEFile(const AFileName: TFileName);
var
  i: Integer;
begin
  for i := 0 to high(FTextFiles) do
    if SameFileName(AFileName, FTextFiles[i].FileName) then
    begin
      GotoFile(i);
      Exit;
    end;

  LoadRTEFile(AFileName);
end;

procedure TmainFrm.RestoreDefaultSettings;
var
  fn: TFileName;
begin
  fn := GetSettingsFileName;
  if FileExists(fn) then
    if not DeleteFile(fn) then
    begin
      ShowErrorMessage('An error occurred while trying to delete the current settings file. No settings will be changed right now.');
      Exit;
    end;

  LoadSettingsFromFile;
end;

procedure TmainFrm.ApplicationEventsException(Sender: TObject; E: Exception);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'Rejbrand Text Editor';
        Title := 'Program Error';
        CommonButtons := [tcbClose];
        MainIcon := tdiError;
        Text := 'Unfortunately, a program error has occurred in Rejbrand Text Editor.' + #13#10#13#10 + 'Rejbrand Text Editor is supposed to be a bug-free application, so the developer would very much appreciate if you reported this error by sending an e-mail to <a href="mailto:andreas@rejbrand.se">andreas@rejbrand.se</a>.'+#13#10#13#10+'In the e-mail, please describe in detail how to reproduce this error. Also include your operating system version and the technical information in the footer of this dialog box.';
        FooterText := E.ClassName + ': ' + E.Message;
        Flags := [tfEnableHyperlinks, tfExpandFooterArea];
        OnHyperlinkClicked := TaskDialogHyperlinkClicked;
        ExecuteModally;
      finally
        Free;
      end
  else
    MessageBox(Handle,
      'Unfortunately, a program error has occurred in Rejbrand Text Editor.' +
        #13#10#13#10 + 'Rejbrand Text Editor is supposed to be a bug-free application, so the developer would very much appreciate if you reported this error by sending an e-mail to andreas@rejbrand.se.'+#13#10#13#10+'In the e-mail, please describe in detail how to reproduce this error. Also include your operating system version and the technical information in the footer of this dialog box.',
      'Rejbrand Text Editor', MB_ICONERROR or MB_OK);
end;

procedure TmainFrm.ApplicationEventsHint(Sender: TObject);
begin
  if Application.Hint <> '' then
  begin
    StatusBar.SimplePanel := true;
    StatusBar.SimpleText := Application.Hint;
  end
  else
  begin
    StatusBar.SimplePanel := false;
    StatusBar.SimpleText := '';
  end;
end;

procedure TmainFrm.ApplicationEventsModalBegin(Sender: TObject);
begin
  if Editor.DisabledEffect <> beNone then
    if Editor.Enabled then
    begin
      FOldDefaultEffect := Editor.BitmapEffect;
      Editor.BitmapEffect := Editor.DisabledEffect;
      FDisabledByModality := true;
    end;
end;

procedure TmainFrm.ApplicationEventsModalEnd(Sender: TObject);
begin
  if Editor.DisabledEffect <> beNone then
    if FDisabledByModality then
    begin
      Editor.BitmapEffect := FOldDefaultEffect;
      FDisabledByModality := false;
    end;
end;

procedure TmainFrm.ApplicationEventsSettingChange(Sender: TObject;
  Flag: Integer; const Section: string; var Result: Integer);
begin
  Editor.EditorCommand(EDITOR_COMMAND_UPDATE_SPI);
end;

procedure TmainFrm.ApplyAssocFormattingProcessor;
var
  ext: string;
begin
  ext := ExtractFileExt(Editor.TextFile.FileName);
  if ext = '' then Exit;
  if ItemInList(ext, FSynHighlightAssocs[SYN_XML]) then
    Editor.FormattingProcessor := XMLFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_HTML]) then
    Editor.FormattingProcessor := HTMLFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_CSS]) then
    Editor.FormattingProcessor := CSSFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_MW]) then
    Editor.FormattingProcessor := MediaWikiFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_PAS]) then
    Editor.FormattingProcessor := PascalFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_AS]) then
    Editor.FormattingProcessor := AlgoSimFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_INI]) then
    Editor.FormattingProcessor := INIFormattingProcessor1
  else
    Editor.FormattingProcessor := nil;
end;

procedure TmainFrm.ApplyAssocReadOnlyMode;
var
  ext: string;
begin
  ext := ExtractFileExt(Editor.TextFile.FileName);
  if ext = '' then Exit;
  if ItemInList(ext, FReadOnlyAssocs) then
    Editor.EditMode := emReadOnly
  else
    Editor.EditMode := emText;
end;

procedure TmainFrm.EncodingMenuSelect;
begin
  if not Editor.TextFile.RecentlyOpened then Exit;

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(Editor.TextFile.FileName);
        Text := 'Do you want to reopen this file using the new encoding?';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Reopen';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              begin
                Screen.Cursor := crHourGlass;
                try
                  Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
                finally
                  Screen.Cursor := crDefault;
                end;
              end;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to reopen this file using the new encoding?',
        PChar(ExtractFileName(Editor.TextFile.FileName)),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        begin
          Screen.Cursor := crHourGlass;
          try
            Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
          finally
            Screen.Cursor := crDefault;
          end;
        end;
    end;

end;

procedure TmainFrm.aBlockPasteExecute(Sender: TObject);
begin
  Editor.PasteFromClipboardAsBlock;
end;

procedure TmainFrm.aBlockPasteUpdate(Sender: TObject);
begin
  aBlockPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
end;

{ TTaskDialogHelper }

function TTaskDialogHelper.ExecuteModally: boolean;
begin
  Application.ModalStarted;
  result := Execute;
  Application.ModalFinished;
end;

end.
