unit settingsWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus;

type
  TsettingsFrm = class(TForm)
    pcSettings: TPageControl;
    tsSynHighAssoc: TTabSheet;
    btnOk: TButton;
    btnCancel: TButton;
    eHTML: TEdit;
    stHTML: TStaticText;
    stCSS: TStaticText;
    eCSS: TEdit;
    stMW: TStaticText;
    eMW: TEdit;
    ePascal: TEdit;
    stPascal: TStaticText;
    eAlgoSim: TEdit;
    stAlgoSim: TStaticText;
    eINI: TEdit;
    stINI: TStaticText;
    eXML: TEdit;
    stXML: TStaticText;
    tsReadOnlyAssoc: TTabSheet;
    stReadOnlyInfo: TStaticText;
    eReadOnlyAdd: TEdit;
    lbReadOnlyAssocs: TListBox;
    pmLbReadOnlyAssocs: TPopupMenu;
    mnuDelete: TMenuItem;
    mnuDeleteAll: TMenuItem;
    tsEffects: TTabSheet;
    stDefEffect: TStaticText;
    cbDefEffect: TComboBox;
    stDisabledEffect: TStaticText;
    cbDisabledEffect: TComboBox;
    tsSettingsFile: TTabSheet;
    stSettingsFileLabel: TStaticText;
    eSettingsDataFile: TEdit;
    tsScroll: TTabSheet;
    rbScrollDef: TRadioButton;
    stScrollLbl: TStaticText;
    rbScrollLine: TRadioButton;
    rbScrollPixel: TRadioButton;
    tsTrimRightAssoc: TTabSheet;
    stTrimInfo: TStaticText;
    eTrimAdd: TEdit;
    lbTrimAssocs: TListBox;
    pmLbTrimAssocs: TPopupMenu;
    mnuDelete2: TMenuItem;
    mnuDeleteAll2: TMenuItem;
    procedure eReadOnlyAddKeyPress(Sender: TObject; var Key: Char);
    procedure eReadOnlyAddEnter(Sender: TObject);
    procedure eReadOnlyAddExit(Sender: TObject);
    procedure lbReadOnlyAssocsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuDeleteAllClick(Sender: TObject);
    procedure mnuDeleteClick(Sender: TObject);
    procedure pmLbReadOnlyAssocsPopup(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pmLbTrimAssocsPopup(Sender: TObject);
    procedure mnuDelete2Click(Sender: TObject);
    procedure mnuDeleteAll2Click(Sender: TObject);
    procedure eTrimAddKeyPress(Sender: TObject; var Key: Char);
    procedure lbTrimAssocsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  settingsFrm: TsettingsFrm;

implementation

uses BitmapEffects, mainWin;

{$R *.dfm}

procedure TsettingsFrm.mnuDeleteClick(Sender: TObject);
begin
  if lbReadOnlyAssocs.ItemIndex <> -1 then
    lbReadOnlyAssocs.Items.Delete(lbReadOnlyAssocs.ItemIndex);
end;

procedure TsettingsFrm.mnuDelete2Click(Sender: TObject);
begin
  if lbTrimAssocs.ItemIndex <> -1 then
    lbTrimAssocs.Items.Delete(lbTrimAssocs.ItemIndex);
end;

procedure TsettingsFrm.mnuDeleteAll2Click(Sender: TObject);
begin
  lbTrimAssocs.Clear;
end;

procedure TsettingsFrm.mnuDeleteAllClick(Sender: TObject);
begin
  lbReadOnlyAssocs.Clear;
end;

procedure TsettingsFrm.eReadOnlyAddEnter(Sender: TObject);
begin
  btnOk.Default := false;
end;

procedure TsettingsFrm.eReadOnlyAddExit(Sender: TObject);
begin
  btnOk.Default := true;
end;

procedure TsettingsFrm.eReadOnlyAddKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = chr(VK_RETURN) then
  begin
    lbReadOnlyAssocs.Items.Add(eReadOnlyAdd.Text);
    Key := #0;
    eReadOnlyAdd.Clear;
  end;
end;

procedure TsettingsFrm.eTrimAddKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = chr(VK_RETURN) then
  begin
    lbTrimAssocs.Items.Add(eTrimAdd.Text);
    Key := #0;
    eTrimAdd.Clear;
  end;
end;

procedure TsettingsFrm.FormCreate(Sender: TObject);
var
  i: TBitmapEffect;
begin
  cbDefEffect.Items.BeginUpdate;
  cbDefEffect.Items.Clear;
  for i := low(TBitmapEffect) to high(TBitmapEffect) do
    cbDefEffect.Items.Add(BitmapEffectsNames[i]);
  cbDefEffect.Items.EndUpdate;
  cbDisabledEffect.Items.Assign(cbDefEffect.Items);

  eSettingsDataFile.Text := mainFrm.GetSettingsFileName;
end;

procedure TsettingsFrm.lbReadOnlyAssocsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE) and (lbReadOnlyAssocs.ItemIndex <> -1) then
    lbReadOnlyAssocs.Items.Delete(lbReadOnlyAssocs.ItemIndex);
end;

procedure TsettingsFrm.lbTrimAssocsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE) and (lbTrimAssocs.ItemIndex <> -1) then
    lbTrimAssocs.Items.Delete(lbTrimAssocs.ItemIndex);
end;

procedure TsettingsFrm.pmLbReadOnlyAssocsPopup(Sender: TObject);
begin
  mnuDelete.Enabled := lbReadOnlyAssocs.ItemIndex <> -1;
  mnuDeleteAll.Enabled := lbReadOnlyAssocs.Count > 0;
end;

procedure TsettingsFrm.pmLbTrimAssocsPopup(Sender: TObject);
begin
  mnuDelete2.Enabled := lbTrimAssocs.ItemIndex <> -1;
  mnuDeleteAll2.Enabled := lbTrimAssocs.Count > 0;
end;

end.
