unit statisticsWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TextEditor, StdCtrls, ActnList, Menus;

type
  TstatisticsFrm = class(TForm)
    gpLines: TGroupBox;
    stLineCountLbl: TStaticText;
    stLineCount: TStaticText;
    stMaxLineLengthLbl: TStaticText;
    stMaxLineLength: TStaticText;
    stAvgLineLengthLbl: TStaticText;
    stAvgLineLength: TStaticText;
    gpCharacters: TGroupBox;
    stCharCountLbl: TStaticText;
    stCharCount: TStaticText;
    stLettersLbl: TStaticText;
    stLetters: TStaticText;
    stDigitsLbl: TStaticText;
    stDigits: TStaticText;
    stWhitespaceLbl: TStaticText;
    stWhitespace: TStaticText;
    stPunctuationLbl: TStaticText;
    stPunctuation: TStaticText;
    gbWords: TGroupBox;
    stWordsLbl: TStaticText;
    stWords: TStaticText;
    stMaxWordLengthLb: TStaticText;
    stMaxWordLength: TStaticText;
    stAvgWordLengthLbl: TStaticText;
    stAvgWordLength: TStaticText;
    btnClose: TButton;
    ActionList1: TActionList;
    aCopyStatisticsToClipboard: TAction;
    statisticsPopup: TPopupMenu;
    Copystatisticstoclipboard1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure aCopyStatisticsToClipboardExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  statisticsFrm: TstatisticsFrm;

implementation

uses mainWin, Clipbrd;

{$R *.dfm}

procedure TstatisticsFrm.aCopyStatisticsToClipboardExecute(Sender: TObject);
var
  i, j: integer;
  s: string;
begin
  s := 'File name: ' + mainFrm.Editor.TextFile.FileName + #13#10#13#10;
  for i := 0 to ControlCount - 1 do
    if Controls[i] is TGroupBox then
      with TGroupBox(Controls[i]) do
      begin
        s := s + Caption + #13#10;
        for j := 0 to ControlCount - 1 do
          if Controls[j] is TStaticText then
            if Pos('Lb', Controls[j].Name) > 0 then
              s := s + TStaticText(Controls[j]).Caption + ' '
            else
              s := s + TStaticText(Controls[j]).Caption + #13#10;
        s := s + #13#10;
      end;
  Clipboard.AsText := s;
end;

procedure TstatisticsFrm.FormCreate(Sender: TObject);
var
  FS: TFileStatistics;
begin
  Screen.Cursor := crHourGlass;
  try
    FS := mainFrm.Editor.TextFile.GetFileStatistics;
  finally
    Screen.Cursor := crDefault;
  end;

  stLineCount.Caption := IntToStr(FS.NumLines);
  stMaxLineLength.Caption := IntToStr(FS.MaxLineLength);
  stAvgLineLength.Caption := FormatFloat('0.##', FS.AvgLineLength);

  stCharCount.Caption := IntToStr(FS.NumChars);
  stLetters.Caption := IntToStr(FS.NumLetters);
  stDigits.Caption := IntToStr(FS.NumDigits);
  stWhitespace.Caption := IntToStr(FS.NumWhitespace);
  stPunctuation.Caption := IntToStr(FS.NumInterpunct);

  stWords.Caption := IntToStr(FS.NumWords);
  stMaxWordLength.Caption := IntToStr(FS.MaxWordLength);
  stAvgWordLength.Caption := FormatFloat('0.##', FS.AvgWordLength);
end;

end.
